
/*********************************************************************************
 *                                                                               *
 * AjustParamDlg.cpp                                                             *
 *                                                                               *
 * Copyright (C) 2000/2002 Fasouil                                               *
 *                                                                               *
 *                                                                               *
 * This program is free software; you can redistribute it and/or                 *
 * modify it under the terms of the GNU General Public License                   *
 * as published by the Free Software Foundation; either version 2                *
 * of the License, or (at your option) any later version.                        *
 *                                                                               *
 *                                                                               *          
 * This program is distributed in the hope that it will be useful,               *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 *
 * GNU General Public License for more details.                                  *
 *                                                                               *
 *                                                                               *
 * You should have received a copy of the GNU General Public License             *
 * along with this program; if not, write to the Free Software                   *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.    *
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html                *
 *                                                                               *
 *                                                                               *
 * The author can be reached at fasouil@hotmail.com                              *
 *********************************************************************************/ 


#include <windows.h>
#ifndef MM_LINUX
#include <Commctrl.h>
#include <process.h>   
#endif
#include <stdio.h>

#include "Structures.h"
#include "resource.h"
#include "AjustParamDlg.h"

const char pAjustParamDlgeClasse[]  = "AjustParamDlgClasse";


CAjustParamDlg::CAjustParamDlg()
{

	m_psArrayKey=NULL;
	m_psToggleArrayKey=NULL;
	m_pbPossiblePrevious=NULL;
	m_pbPossibleNormal=NULL;
	m_psCountKeyLineNormal=NULL;
	m_pnPositionLineNormal=NULL;
	m_ppsAdressKeyLineNormal=NULL;
	m_pcKeyLineNormal=NULL;
	m_pnPositionLinePrevious=NULL;
	m_psCountKeyLinePrevious=NULL;
	m_ppsAdressKeyLinePrevious=NULL;
	m_pcKeyLinePrevious=NULL;
	m_pnArrayMaskPurple=NULL;
	m_psKeyMaskPurple=NULL;
	m_pnArrayMaskChromi=NULL;
	m_psKeyMaskChromi=NULL;

	m_bThreadBuildFPCActive=false;
	m_bThreadBuildFPCPermit=false;
	m_nTestNormalMaxi=0;
	m_nTestPreviousMaxi=0;
	m_nTestNormalMaxiOld=0;
	m_nTestPreviousMaxiOld=0;
	ZeroMemory(m_bFileOK,sizeof(m_bFileOK));

	m_bFilterSecam=false;
	m_bFilterPurple=false;		// cricri
	m_bFilterAverage = false;	// cricri

	// NiKral
	m_nPurpleLevel=DEFAULTPURPLELEVEL;
	m_bFilterSSE = false;
	m_bCapCrypt= false;
	m_bCapHalfField= false;

	m_bAllFileCheck=false;
	m_bUpdateFile=false;
	m_nTestNormalUser=0;
	m_nTestPreviousUser=0;
	m_bFullField=false;

}

CAjustParamDlg::~CAjustParamDlg()
{
	DestroyAllVariables();

}


#ifndef MM_LINUX
int CAjustParamDlg::DoModal(HINSTANCE hInstance,HWND hWndParent)
{
	m_bAllFileCheck=false;
	m_bUpdateFile=false;

   return DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_REGLAGE_MEUHMEUH), hWndParent, (DLGPROC)ProcessMessage, (LPARAM)this);
}
 

BOOL CALLBACK CAjustParamDlg::ProcessMessage(HWND hWnd,UINT uMessage,WPARAM wParam,LPARAM lParam)
{
	char pValue[60];

	switch(uMessage)
	{
		case WM_INITDIALOG:
		{
			CAjustParamDlg *pAjustParam = (CAjustParamDlg*)lParam;
			SetProp(hWnd, pAjustParamDlgeClasse, pAjustParam);

            SetDlgItemText( hWnd, IDC_STATIC1, DESCRIPTION);    // cricri
			pAjustParam->SetDialogData(hWnd);

			return TRUE;
		}
		break;

		case WM_NOTIFY:
		{
			switch(LOWORD(wParam))
			{
				case IDC_SLIDER_MOVE:
				{
					CAjustParamDlg *pAjustParam = (CAjustParamDlg*)GetProp(hWnd, pAjustParamDlgeClasse);
					pAjustParam->m_nTestNormalUser=TESTNORMALMAXI-SendDlgItemMessage(hWnd,IDC_SLIDER_MOVE,TBM_GETPOS,0,0);

					pAjustParam->CheckParameter();

					sprintf(pValue, "%d", pAjustParam->m_nTestNormalUser);
					SetDlgItemText(hWnd, IDC_EDIT_MOVE, pValue);

				}	
				break;

				case IDC_SLIDER_FIXE:
				{
					CAjustParamDlg *pAjustParam = (CAjustParamDlg*)GetProp(hWnd, pAjustParamDlgeClasse);
					pAjustParam->m_nTestPreviousUser=TESTPREVIOUSMAXI-SendDlgItemMessage(hWnd,IDC_SLIDER_FIXE,TBM_GETPOS,0,0);

					pAjustParam->CheckParameter();

					sprintf(pValue, "%d", pAjustParam->m_nTestPreviousUser);
					SetDlgItemText(hWnd, IDC_EDIT_FIXE, pValue);

				}	
				break;

				case IDC_SPIN_PURPLE:
				{
					CAjustParamDlg *pAjustParam = (CAjustParamDlg*)GetProp(hWnd, pAjustParamDlgeClasse);

					if (((LPNMUPDOWN)(lParam))->iDelta > 0)
						pAjustParam->m_nPurpleLevel-= 5;
					else
						pAjustParam->m_nPurpleLevel+= 5;

					if (pAjustParam->m_nPurpleLevel < PURPLELEVELMINI) pAjustParam->m_nPurpleLevel = PURPLELEVELMINI;
					if (pAjustParam->m_nPurpleLevel > PURPLELEVELMAXI) pAjustParam->m_nPurpleLevel = PURPLELEVELMAXI;

					sprintf(pValue, "%d", pAjustParam->m_nPurpleLevel);
					SetDlgItemText(hWnd, IDC_PURPLE_LEVEL, pValue);
				}	
				break;
			}

		}
		break;


		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_SELECT_FILE:	// NiKral
				{
				    OPENFILENAME fName;
					char sFileName[MAX_PATH];
					sFileName[0] = '\0';

					fName.lStructSize = sizeof(fName);
					fName.hwndOwner = hWnd;
					fName.hInstance = NULL;
					fName.lpstrFilter = "Images BMP (*.bmp)\0*.bmp\0";
					fName.lpstrCustomFilter = NULL;
					fName.nFilterIndex = 1;
					fName.lpstrFile = sFileName;
					fName.nMaxFile = MAX_PATH;
					fName.lpstrFileTitle = NULL;
					fName.nMaxFileTitle = 0;
					fName.lpstrInitialDir = NULL;
					fName.nFileOffset = 0;
					fName.nFileExtension = 0;
					fName.lpstrDefExt = NULL;
					fName.lpstrTitle = "Slectionner un fichier de capture";
					fName.Flags = OFN_OVERWRITEPROMPT + OFN_PATHMUSTEXIST + OFN_HIDEREADONLY + OFN_NOCHANGEDIR;
					if (GetSaveFileName(&fName))
					{
						SetDlgItemText(hWnd,IDC_FILENAME,sFileName);
					}
				}
				break;
				
				case IDOK:
				{

					//le fichier key.txt existe
		   			CAjustParamDlg *pAjustParam = (CAjustParamDlg*)GetProp(hWnd, pAjustParamDlgeClasse);
					if (pAjustParam->GetDialogData(hWnd))
					{

						//disable OK
						EnableWindow(GetDlgItem(hWnd, IDOK), FALSE);
						UpdateWindow(hWnd);

						//enable thread FPC
						if ((!pAjustParam->m_bAllFileCheck)
							||(pAjustParam->m_nTestPreviousMaxi!=pAjustParam->m_nTestPreviousMaxiOld)
							||(pAjustParam->m_nTestNormalMaxi!=pAjustParam->m_nTestNormalMaxiOld))
						{
							pAjustParam->m_bThreadBuildFPCPermit=true;
							_beginthread(pAjustParam->ThreadBuildFPC,0, hWnd );		// dmarrage du thread vido
						}
						else
							EndDialog(hWnd, LOWORD(wParam));
					}

					return TRUE;
				}
		        break;

				case IDCANCEL:
				{

					CAjustParamDlg *pAjustParam = (CAjustParamDlg*)GetProp(hWnd, pAjustParamDlgeClasse);

					if (pAjustParam->m_bThreadBuildFPCActive)
					{	//gnration en cours -> on stopppe
						if (MessageBox(hWnd,"Arreter la gnration des fichiers FPC ?","MeuhMeuhPlug",MB_OKCANCEL|MB_ICONQUESTION)==IDOK)
						{
							pAjustParam->m_bThreadBuildFPCPermit=false;
							Sleep(10);
						}
					}
					else
					{
						//on quitte la fenetre
						RemoveProp(hWnd, pAjustParamDlgeClasse);
               			EndDialog(hWnd, LOWORD(wParam));
					}

					return TRUE;
				}
				break;
			}
		break;
	}

	return FALSE;
}
#endif // MM_LINUX


void CAjustParamDlg::CheckFiles()
{
	m_bFileOK[0]=LoadFileKey();

	m_bFileOK[1]=LoadFilePossibleNormal();

	m_bFileOK[2]=LoadFilePossiblePrevious();

	m_bFileOK[3]=CheckFileLineNormal();

	m_bFileOK[4]=CheckFileLinePrevious();

	m_bFileOK[5]=CheckFilePurple();

	m_bFileOK[6]=CheckFileChromi();
	
	if (!m_bFileOK[1])
		m_bFileOK[3]=FALSE;

	if (!m_bFileOK[2])
		m_bFileOK[4]=FALSE;

	if ((m_bFileOK[0])
		&&(m_bFileOK[1])
		&&(m_bFileOK[2])
		&&(m_bFileOK[3])
		&&(m_bFileOK[4])
		&&(m_bFileOK[5])
		&&(m_bFileOK[6]))
		m_bAllFileCheck=true;
	else
		m_bAllFileCheck=false;
}



#ifndef MM_LINUX
BOOL CAjustParamDlg::GetDialogData(HWND hWnd)
{
	m_bFilterSecam=(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_FILTER_SECAM));

	m_bFilterPurple=(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_FILTER_PURPLE));

	m_bFilterAverage=(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_FILTER_AVERAGE));	// cricri

	m_bFilterSSE=(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_FILTER_SSE));		// NiKral

	m_bFullField=(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_DOUBLE_TRAME));

	GetWindowText(GetDlgItem(hWnd, IDC_FILENAME), sCaptureFileName, MAX_PATH);	// NiKral

	m_bCapCrypt=(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_TYPE_IMAGE));		// NiKral

	m_bCapHalfField=(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_ONE_FRAME));	// NiKral

	char pValue[40];

   	GetWindowText(GetDlgItem(hWnd, IDC_EDIT_MOVE), pValue, sizeof(pValue));
   	m_nTestNormalUser = atoi(pValue);

   	GetWindowText(GetDlgItem(hWnd, IDC_EDIT_FIXE), pValue, sizeof(pValue));
   	m_nTestPreviousUser = atoi(pValue);

	// NiKral
   	GetWindowText(GetDlgItem(hWnd, IDC_PURPLE_LEVEL), pValue, sizeof(pValue));
   	m_nPurpleLevel = atoi(pValue);

	CheckParameter();

	if ((m_nTestPreviousMaxi<2)||(m_nTestNormalMaxi<2))
	{
		MessageBox(hWnd,"Choisissez un nombre d'itrations suprieur  1 !",NULL,MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	return TRUE;

}
#endif



BOOL CAjustParamDlg::GenerateFiles(HWND hWnd)
{
	int i;

#ifndef MM_LINUX
	SetDlgItemText(hWnd, IDC_NOM1, "");
	SetDlgItemText(hWnd, IDC_NOM2, "");
#endif


	if (!m_bThreadBuildFPCPermit)
		return FALSE;
#ifdef MM_LINUX
//// Ajout initialisation  pour chercher les datas manquantes (ancien setdialogdata)
         //cherche le nombre d'iterration dans les fichier prsents
	m_nTestPreviousMaxi=0;
	m_nTestNormalMaxi=0;
	CheckFiles();

	//mmorise m_nTestPreviousMaxi
	m_nTestPreviousMaxiOld=m_nTestPreviousMaxi;
	m_nTestNormalMaxiOld=m_nTestNormalMaxi;

	if ((m_nTestNormalUser<0)||(m_nTestPreviousUser<0))
		AutoTestLineTestMaxi();

	if (m_nTestNormalMaxi!=TESTNORMALMAXI)
		m_nTestNormalMaxi=TESTNORMALMAXI;
	if (m_nTestPreviousMaxi!=TESTPREVIOUSMAXI)
		m_nTestPreviousMaxi=TESTPREVIOUSMAXI;

	//CheckParameter
	CheckParameter();	

///// fin
#endif

	if (m_nTestPreviousMaxi!=m_nTestPreviousMaxiOld)
		m_bFileOK[4]=FALSE;

	if (m_nTestNormalMaxi!=m_nTestNormalMaxiOld)
		m_bFileOK[3]=FALSE;

	if (!LoadFileKey())
	{
		OutputDebugString("Impossible de lire le fichier key.txt");
	    return FALSE;
	}


	m_psArrayKey = new short[128*256*CURRENTY];
	if(m_psArrayKey == NULL)
	{
		OutputDebugString("IDS_ERR_MEMORY");
		return FALSE;
	}

	m_psToggleArrayKey = new short[128*256*(CURRENTY+1)];
	if(m_psToggleArrayKey == NULL)
	{
		OutputDebugString("IDS_ERR_MEMORY");
	    return FALSE;
	}

	m_pbPossiblePrevious = new bool[CURRENTY*CURRENTY];
	if(!m_pbPossiblePrevious)
	    return FALSE;

	m_pbPossibleNormal = new bool[CURRENTY*CURRENTY];
	if(!m_pbPossibleNormal)
        return FALSE;
	
	m_pnArrayMaskPurple=new unsigned __int64[128*256];
	if (m_pnArrayMaskPurple==NULL)
		return false;

	m_psKeyMaskPurple=new short[128*256];
	if (m_psKeyMaskPurple==NULL)
		return false;

	m_pnArrayMaskChromi=new unsigned __int64[128*256];
	if (m_pnArrayMaskChromi==NULL)
		return false;

	m_psKeyMaskChromi=new short[128*256];
	if (m_psKeyMaskChromi==NULL)
		return false;

	CreateArrayKey();


	int nTotalFileBuild=0;
	int nTotalFileBuilt=0;
	for (i=1;i<7;i++)
	{
		if (!m_bFileOK[i])
			nTotalFileBuild++;
	}
	

#ifndef MM_LINUX
	SetDlgItemText(hWnd, IDC_NOM1, "Gnration en cours ...");
#else
        printf("MeuhMeuh : Gnration en cours des fichiers fpc veuillez Patienter ...");
#endif
	for (i=1;i<7;i++)
	{

		int nProgresse1=0;
		if (nTotalFileBuild>0)
			nProgresse1=(nTotalFileBuilt*100/nTotalFileBuild);
#ifndef MM_LINUX
		SendDlgItemMessage(hWnd,IDC_PROGRESS1,PBM_SETPOS,nProgresse1,0);

		SendDlgItemMessage(hWnd,IDC_PROGRESS2,PBM_SETPOS,0,0);	//0%
		UpdateWindow(hWnd);
#else
                printf("\nProgression totale %d/100\n", nProgresse1);
		//fflush(stdout);
                //sleep(2);
#endif

		if (!m_bThreadBuildFPCPermit)
			return FALSE;

		if (i==1)
		{
			if (!m_bFileOK[i])
			{
#ifndef MM_LINUX
				SetDlgItemText(hWnd, IDC_NOM2, File_PossibleNormal);
				UpdateWindow(hWnd);
#endif
				if (CalculPossibleNormal(hWnd))
				{
					SaveFilePossibleNormal();
					m_bFileOK[i]=TRUE;
					nTotalFileBuilt++;
				}

			}
			else
			{
				if (!LoadFilePossibleNormal())
				{
					OutputDebugString("Erreur lecture fichier normalpos.fpc");
					return FALSE;
				}
			}

		}

		if (i==2)
		{
			if (!m_bFileOK[i])
			{
#ifndef MM_LINUX
				SetDlgItemText(hWnd, IDC_NOM2, File_PossiblePrevious);
				UpdateWindow(hWnd);
#endif
				if (CalculPossiblePrevious(hWnd))
				{
					SaveFilePossiblePrevious();
					m_bFileOK[i]=TRUE;
					nTotalFileBuilt++;
				}
			}
			else
			{
				if (!LoadFilePossiblePrevious())
				{
					OutputDebugString("Erreur lecture fichier accelerepos.fpc");
					return FALSE;
				}

			}
		}

		if ((i==3)&&(!m_bFileOK[i]))
		{
			if (!m_bFileOK[1])
			{
#ifndef MM_LINUX
				MessageBox(hWnd,"Fichier normalpos.fpc nnessaire !","MeuhMeuhTV",MB_OK|MB_ICONSTOP);
#else
				printf ("MeuhMeuh : Fichier normalpos.fpc nnessaire !\n");
#endif
			}
			else
			{
#ifndef MM_LINUX
				SetDlgItemText(hWnd, IDC_NOM2, File_LineNormal);
				UpdateWindow(hWnd);
#endif
				if (GenerateLineNormal(hWnd))
				{
					SaveFileLineNormal();
					nTotalFileBuilt++;
				}
			}
		}

		
		if ((i==4)&&(!m_bFileOK[i]))
		{
			if (!m_bFileOK[2])
			{
#ifndef MM_LINUX
				MessageBox(hWnd,"Fichier accelerepos.fpc nnessaire !","MeuhMeuhTV",MB_OK|MB_ICONSTOP);
#else
				printf ("MeuhMeuh : Fichier accelerepos.fpc nnessaire !\n");
#endif
			}
			else
			{
#ifndef MM_LINUX
				SetDlgItemText(hWnd, IDC_NOM2, File_LinePrevious);
				UpdateWindow(hWnd);
#endif
				if (GenerateLinePrevious(hWnd))
				{
					SaveFileLinePrevious();
					nTotalFileBuilt++;
				}
			}
		}

		if ((i==5)&&(!m_bFileOK[i]))
		{
#ifndef MM_LINUX
			SetDlgItemText(hWnd, IDC_NOM2, File_PurpleKey);
			UpdateWindow(hWnd);
#endif
			if (GenerateArrayMaskPurple(hWnd))
			{
				SaveFilePurple();
				nTotalFileBuilt++;
			}
			
		}

		if ((i==6)&&(!m_bFileOK[i]))
		{
#ifndef MM_LINUX
			SetDlgItemText(hWnd, IDC_NOM2, File_ChromiKey);
			UpdateWindow(hWnd);
#endif
			if (GenerateArrayMaskChromi(hWnd))
			{
				SaveFileChromi();
				nTotalFileBuilt++;
			}
			
		}

	}
#ifdef MM_LINUX
        printf("\nFin de la gnration\n");
        fflush(stdout);
#endif

	if (!m_bThreadBuildFPCPermit)
		return FALSE;


	return(TRUE);
}


BOOL CAjustParamDlg::SaveFileLineNormal()
{
   
   int nLineIndex;
#ifndef MM_LINUX
   CreateDirectory( PLUGIN_SUBDIR,(LPSECURITY_ATTRIBUTES)NULL);	
#endif
   FILE *sFile = fopen( File_LineNormal, "wb");
   int nFullSize;

   if(sFile == NULL)
      return FALSE;

	//file ID
	fwrite(cFileID, sizeof(cFileID),1,sFile);   
	fwrite(cFileVersion, sizeof(cFileVersion),1,sFile);   

   // nombre de ligne
   fwrite(&m_nTestNormalMaxi, sizeof(m_nTestNormalMaxi),1,sFile);   

   //taille totale
   nFullSize=m_ppsAdressKeyLineNormal[m_nTestNormalMaxi*CURRENTY*CURRENTY]-m_psCountKeyLineNormal;
   fwrite(&nFullSize, sizeof(nFullSize),1,sFile);

   //enregistre les valeurs des clefs (tableau dynamique)
   fwrite(m_psCountKeyLineNormal, sizeof(*m_psCountKeyLineNormal),nFullSize,sFile);

   
   for (nLineIndex=0;nLineIndex<m_nTestNormalMaxi;nLineIndex++)
   {
	   // enregistre le numro de la ligne
	   fwrite(m_pnPositionLineNormal+nLineIndex, sizeof(*m_pnPositionLineNormal),1,sFile);

	   // enregistre le nombre de clef par ligne,ligne
	   fwrite(m_pcKeyLineNormal+nLineIndex*CURRENTY*CURRENTY, sizeof(*m_pcKeyLineNormal),CURRENTY*CURRENTY,sFile);
   }


   fclose(sFile);
   
   m_bUpdateFile=true;
   
   return TRUE;
}


BOOL CAjustParamDlg::SaveFileLinePrevious()
{

	int nLineIndex;
#ifndef MM_LINUX
	CreateDirectory( PLUGIN_SUBDIR,(LPSECURITY_ATTRIBUTES)NULL);	
#endif
	FILE *sFile = fopen( File_LinePrevious, "wb");
	int nFullSize;

	if(sFile == NULL)
		return FALSE;

	//file ID
	fwrite(cFileID, sizeof(cFileID),1,sFile);   
	fwrite(cFileVersion, sizeof(cFileVersion),1,sFile);   

	// nombre de ligne
	fwrite(&m_nTestPreviousMaxi, sizeof(m_nTestPreviousMaxi),1,sFile);
   
	//taille totale
	nFullSize=m_ppsAdressKeyLinePrevious[m_nTestPreviousMaxi*CURRENTY*CURRENTY]-m_psCountKeyLinePrevious;
	fwrite(&nFullSize, sizeof(nFullSize),1,sFile);

	//enregistre les valeurs des clefs (tableau dynamique)
	fwrite(m_psCountKeyLinePrevious, sizeof(*m_psCountKeyLinePrevious),nFullSize,sFile);

	for (nLineIndex=0;nLineIndex<m_nTestPreviousMaxi;nLineIndex++)
	{
		// enregistre le numro de la ligne
		fwrite(m_pnPositionLinePrevious+nLineIndex, sizeof(*m_pnPositionLinePrevious),1,sFile);

		// enregistre le nombre de clef par ligne,ligne
		fwrite(m_pcKeyLinePrevious+nLineIndex*CURRENTY*CURRENTY, sizeof(*m_pcKeyLinePrevious),CURRENTY*CURRENTY,sFile);
	}

	fclose(sFile);
	m_bUpdateFile=true;
	return TRUE;
}


BOOL CAjustParamDlg::SaveFilePossiblePrevious()
{

#ifndef MM_LINUX
	CreateDirectory( PLUGIN_SUBDIR,(LPSECURITY_ATTRIBUTES)NULL);	
#endif
	FILE *sFile = fopen( File_PossiblePrevious, "wb");

	if(sFile == NULL)
		return FALSE;

	//file ID
	fwrite(cFileID, sizeof(cFileID),1,sFile);   
	fwrite(cFileVersion, sizeof(cFileVersion),1,sFile);   

	fwrite(m_pbPossiblePrevious, sizeof(*m_pbPossiblePrevious),CURRENTY*CURRENTY,sFile);

	fclose(sFile);
	m_bUpdateFile=true;
	return TRUE;
}


BOOL CAjustParamDlg::SaveFilePossibleNormal()
{

#ifndef MM_LINUX
	CreateDirectory( PLUGIN_SUBDIR,(LPSECURITY_ATTRIBUTES)NULL);	
#endif
	FILE *sFile = fopen( File_PossibleNormal, "wb");

	if(sFile == NULL)
		return FALSE;

	//file ID
	fwrite(cFileID, sizeof(cFileID),1,sFile);   
	fwrite(cFileVersion, sizeof(cFileVersion),1,sFile);   

	fwrite(m_pbPossibleNormal, sizeof(*m_pbPossibleNormal),CURRENTY*CURRENTY,sFile);

	fclose(sFile);
	m_bUpdateFile=true;
	return TRUE;
}



BOOL CAjustParamDlg::CalculPossiblePrevious(HWND hWnd)
{
	int nKeyTested;
	int nLinePosition;
	int nLinePossiblePosition;
	int nValueCurrent=0;
	int nValueOld=-1;
	short * pLineOrder;

	ZeroMemory(m_pbPossiblePrevious,CURRENTY*CURRENTY*sizeof(*m_pbPossiblePrevious));

	for (nLinePosition=0;nLinePosition<CURRENTY;nLinePosition++)
	{
		if (!m_bThreadBuildFPCPermit)
			return FALSE;

		nValueCurrent=nLinePosition*100/CURRENTY;
		if (nValueCurrent!=nValueOld)
		{
#ifndef MM_LINUX
			SendDlgItemMessage(hWnd,IDC_PROGRESS2,PBM_SETPOS,nValueCurrent,0);
			UpdateWindow(hWnd);
#else
			printf("\rGnration PossiblePrevious %d/100                ",nValueCurrent);
			fflush(stdout);
#endif
		}
		nValueOld=nValueCurrent;

		for (nLinePossiblePosition=0;nLinePossiblePosition<CURRENTY;nLinePossiblePosition++)
		{
			//m_pbPossiblePrevious[nLinePosition*CURRENTY+nLinePossiblePosition]=false;
			for (nKeyTested=0;nKeyTested<128*256;nKeyTested++)
			{
				pLineOrder=m_psArrayKey+nKeyTested*CURRENTY;
				if (pLineOrder[nLinePosition]==nLinePossiblePosition)
				{
					m_pbPossiblePrevious[nLinePosition*CURRENTY+nLinePossiblePosition]=true;
					break;
				}
	
			}
		}
		
	}
	
	return (TRUE);
 
} 



BOOL CAjustParamDlg::CalculPossibleNormal(HWND hWnd)
{	// dans une image crypte
	// la ligne situ au dessous de la ligne x peut elle tre  la place y ?
	int nKeyTested;
	int nLinePosition;
	int nLinePossiblePosition;
	int nValueCurrent=0;
	int nValueOld=-1;
	short * pLineOrder;

	ZeroMemory(m_pbPossibleNormal,CURRENTY*CURRENTY*sizeof(*m_pbPossibleNormal));

	for (nLinePosition=0;nLinePosition<CURRENTY;nLinePosition++)
	{
		if (!m_bThreadBuildFPCPermit)
			return FALSE;

		nValueCurrent=nLinePosition*100/CURRENTY;
		if (nValueCurrent!=nValueOld)
		{
#ifndef MM_LINUX
			SendDlgItemMessage(hWnd,IDC_PROGRESS2,PBM_SETPOS,nValueCurrent,0);
			UpdateWindow(hWnd);
#else
			printf("\rGnration PossibleNormal %d/100                  ",nValueCurrent);
			fflush(stdout);
#endif
		}
		nValueOld=nValueCurrent;

		for (nLinePossiblePosition=0;nLinePossiblePosition<CURRENTY;nLinePossiblePosition++)
		{
			for (nKeyTested=0;nKeyTested<128*256;nKeyTested++)
			{
				pLineOrder=m_psToggleArrayKey+nKeyTested*CURRENTY;
				if (pLineOrder[nLinePosition]==pLineOrder[nLinePossiblePosition]-1)
				{
					m_pbPossibleNormal[nLinePosition*CURRENTY+nLinePossiblePosition]=true;
					break;
				}
	
			}
		}
		
	}

	return (TRUE);

}


BOOL CAjustParamDlg::GenerateLinePrevious(HWND hWnd)
{
	int i;
 

	m_pnPositionLinePrevious = new BOOL[m_nTestPreviousMaxi];
	if(m_pnPositionLinePrevious == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return FALSE;
	}

	m_psCountKeyLinePrevious = new short[m_nTestPreviousMaxi*80000];
	if(m_psCountKeyLinePrevious == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return FALSE;
	}


	m_ppsAdressKeyLinePrevious = new short * [m_nTestPreviousMaxi*CURRENTY*CURRENTY+1];
	if(m_ppsAdressKeyLinePrevious == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return FALSE;
	}

	m_pcKeyLinePrevious=new unsigned char[m_nTestPreviousMaxi*CURRENTY*CURRENTY];
	if(m_pcKeyLinePrevious == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return FALSE;
	}

	#define TAILLEMAXICLEFPOSSIBLE 3000
	short * TableM0=NULL;
	short * TableM4=NULL;

	TableM0 = new short[CURRENTY*TAILLEMAXICLEFPOSSIBLE];
	if(TableM0 == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return FALSE;
	}

	TableM4 = new short[CURRENTY*TAILLEMAXICLEFPOSSIBLE];
	if(TableM4 == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return FALSE;
	}

	
	for (i=0;i<m_nTestPreviousMaxi;i++)
	{
		//calcul position line
		m_pnPositionLinePrevious[i]=286/(int(m_nTestPreviousMaxi/2)*2+2)*(i+1);

		if (!CalculLinePrevious(i,hWnd,TableM0,TableM4))
			return FALSE;

	}

	if(TableM0 != NULL)
    	delete[]TableM0;
	TableM0=NULL;
	if(TableM4 != NULL)
    	delete[]TableM4;
	TableM4=NULL;


	return (TRUE);
}


BOOL CAjustParamDlg::GenerateLineNormal(HWND hWnd)
{
	int i;

	m_psCountKeyLineNormal = new short[m_nTestNormalMaxi*80000];
	if(m_psCountKeyLineNormal == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return FALSE;
	}

	m_pnPositionLineNormal = new int[m_nTestNormalMaxi];
	if(m_pnPositionLineNormal == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return FALSE;
	}

	m_ppsAdressKeyLineNormal = new short * [m_nTestNormalMaxi*CURRENTY*CURRENTY+1];
	if(m_ppsAdressKeyLineNormal == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return FALSE;
	}

	m_pcKeyLineNormal=new unsigned char[m_nTestNormalMaxi*CURRENTY*CURRENTY];

	if(m_pcKeyLineNormal == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return FALSE;
	}


	#define TAILLEMAXICLEFPOSSIBLE 3000
	short * TableDessous=NULL;
	short * TableDessus=NULL;

	TableDessous = new short[CURRENTY*TAILLEMAXICLEFPOSSIBLE];
	if(TableDessous == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return FALSE;
	}

	TableDessus = new short[CURRENTY*TAILLEMAXICLEFPOSSIBLE];
	if(TableDessus == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return FALSE;
	}

	for (i=0;i<m_nTestNormalMaxi;i++)
	{
		//calcul position line
		m_pnPositionLineNormal[i]=287/(m_nTestNormalMaxi+1)*(i+1);
		
		if (!CalculLineNormal(i,hWnd,TableDessous,TableDessus))
			return (FALSE);
	}


	if(TableDessus != NULL)
    	delete[]TableDessus;
	TableDessus=NULL;
	if(TableDessous != NULL)
    	delete[]TableDessous; 
	TableDessous=NULL;
	

	return (TRUE);
}

BOOL CAjustParamDlg::CalculLineNormal(int nLineIndex,HWND hWnd,short * TableDessous,short * TableDessus)  
{
	int nKeyTested;
	unsigned char cFoundCounter;
	int py;
	int nFoundCounterBottom[CURRENTY],nFoundCounterTop[CURRENTY];
	int nIndexKeyTested,nIndexKeyTested2;
	int nBottomNearLine,nTopNearLine;
	short * psPointerKey;
	int nValueCurrent=0;
	int nValueOld=-1;
	short * pLineOrder;


	// bottom
	for (py=0;py<CURRENTY;py++)
	{
		nFoundCounterBottom[py]=0;
		if (m_pbPossibleNormal[m_pnPositionLineNormal[nLineIndex]*CURRENTY+py])
		{
			for (nKeyTested=0;nKeyTested<128*256;nKeyTested++)
			{
				pLineOrder=m_psToggleArrayKey+nKeyTested*CURRENTY;
				if (pLineOrder[m_pnPositionLineNormal[nLineIndex]]==pLineOrder[py]-1)
				{
					TableDessous[py*TAILLEMAXICLEFPOSSIBLE+nFoundCounterBottom[py]]=(short)nKeyTested;
					nFoundCounterBottom[py]++;
				}
			}
		}
	}

	// top
	for (py=0;py<CURRENTY;py++)
	{
		nFoundCounterTop[py]=0;
		if (m_pbPossibleNormal[m_pnPositionLineNormal[nLineIndex]+py*CURRENTY])
		{
			for (nKeyTested=0;nKeyTested<128*256;nKeyTested++)
			{
				pLineOrder=m_psToggleArrayKey+nKeyTested*CURRENTY;
				if (pLineOrder[m_pnPositionLineNormal[nLineIndex]]==pLineOrder[py]+1)
				{
					TableDessus[py*TAILLEMAXICLEFPOSSIBLE+nFoundCounterTop[py]]=(short)nKeyTested;
					nFoundCounterTop[py]++;
				}
			}
		}
	}

	
	// top and bottom
	if (nLineIndex==0)
		psPointerKey=m_psCountKeyLineNormal;
	else
		psPointerKey=m_ppsAdressKeyLineNormal[nLineIndex*CURRENTY*CURRENTY];

	for (nBottomNearLine=0;nBottomNearLine<CURRENTY;nBottomNearLine++)
	{
		if (!m_bThreadBuildFPCPermit)
			return FALSE;

		//display %
		nValueCurrent=nLineIndex*100/m_nTestNormalMaxi + nBottomNearLine*100/m_nTestNormalMaxi/CURRENTY;
		if (nValueCurrent!=nValueOld)
		{
#ifndef MM_LINUX
			SendDlgItemMessage(hWnd,IDC_PROGRESS2,PBM_SETPOS,nValueCurrent,0);
			UpdateWindow(hWnd);
#else
			printf("\rGnration LineNormal %d/100                     ",nValueCurrent);
			fflush(stdout);
#endif
		}
		nValueOld=nValueCurrent;

		for (nTopNearLine=0;nTopNearLine<CURRENTY;nTopNearLine++)
		{
			cFoundCounter=0;
			for (nIndexKeyTested=0;nIndexKeyTested<nFoundCounterBottom[nBottomNearLine];nIndexKeyTested++)
			{
				nKeyTested=TableDessous[nBottomNearLine*TAILLEMAXICLEFPOSSIBLE+nIndexKeyTested];
				for (nIndexKeyTested2=0;nIndexKeyTested2<nFoundCounterTop[nTopNearLine];nIndexKeyTested2++)
				{
					if (nKeyTested==TableDessus[nTopNearLine*TAILLEMAXICLEFPOSSIBLE+nIndexKeyTested2])
					{
						*(psPointerKey+cFoundCounter)=(short)nKeyTested;
						cFoundCounter++;
					}
					if (TableDessus[nTopNearLine*TAILLEMAXICLEFPOSSIBLE+nIndexKeyTested2]>nKeyTested)
						break;

				}
			}

			m_ppsAdressKeyLineNormal[nLineIndex*CURRENTY*CURRENTY+nBottomNearLine*CURRENTY+nTopNearLine]=psPointerKey;
			psPointerKey+=cFoundCounter;

			m_pcKeyLineNormal[nLineIndex*CURRENTY*CURRENTY+nBottomNearLine*CURRENTY+nTopNearLine]=cFoundCounter;

		}
	
	}
	m_ppsAdressKeyLineNormal[(nLineIndex+1)*CURRENTY*CURRENTY]=psPointerKey;

	return (TRUE);

}


BOOL CAjustParamDlg::CalculLinePrevious(int nLineIndex,HWND hWnd,short * TableM0,short * TableM4)  
{
	int nKeyTested;
	unsigned char cFoundCounter;
	int py;
	int nFoundCounterCurrent[CURRENTY],nFoundCounterM4[CURRENTY];
	int nIndexKeyTested,nIndexKeyTested2;
	int nCurrentNearLine,nM4NearLine;
	short * psPointerKey;
	int nValueCurrent=0;
	int nValueOld=-1;
	short * pLineOrder;

	// current -> same line
	for (py=0;py<CURRENTY;py++)
	{
		nFoundCounterCurrent[py]=0;
		if (m_pbPossiblePrevious[m_pnPositionLinePrevious[nLineIndex]*CURRENTY+py])
		{
			for (nKeyTested=0;nKeyTested<128*256;nKeyTested++)
			{

				pLineOrder=m_psToggleArrayKey+nKeyTested*CURRENTY;
				if (m_pnPositionLinePrevious[nLineIndex]==pLineOrder[py])
				{
					TableM0[py*TAILLEMAXICLEFPOSSIBLE+nFoundCounterCurrent[py]]=(short)nKeyTested;
					nFoundCounterCurrent[py]++;
				}

			}
		}
	}


	// M4 (ECARTLIGNESUPERPOSITION lines bottom current line)
	for (py=0;py<CURRENTY;py++)
	{
		nFoundCounterM4[py]=0;
		if (m_pbPossiblePrevious[(m_pnPositionLinePrevious[nLineIndex]+ECARTLIGNESUPERPOSITION)*CURRENTY+py])
		{
			for (nKeyTested=0;nKeyTested<128*256;nKeyTested++)
			{
				pLineOrder=m_psToggleArrayKey+nKeyTested*CURRENTY;
				if (m_pnPositionLinePrevious[nLineIndex]+ECARTLIGNESUPERPOSITION==pLineOrder[py])
				{
					TableM4[py*TAILLEMAXICLEFPOSSIBLE+nFoundCounterM4[py]]=(short)nKeyTested;
					nFoundCounterM4[py]++;
				}
			}
		}
	}


	
	// current and M4
	if (nLineIndex==0)
		psPointerKey=m_psCountKeyLinePrevious;
	else
		psPointerKey=m_ppsAdressKeyLinePrevious[nLineIndex*CURRENTY*CURRENTY];

	for (nCurrentNearLine=0;nCurrentNearLine<CURRENTY;nCurrentNearLine++)
	{
		if (!m_bThreadBuildFPCPermit)
			return FALSE;

		//display %
		nValueCurrent=nLineIndex*100/m_nTestPreviousMaxi + nCurrentNearLine*100/m_nTestPreviousMaxi/CURRENTY;
		if (nValueCurrent!=nValueOld)
		{
#ifndef MM_LINUX
			SendDlgItemMessage(hWnd,IDC_PROGRESS2,PBM_SETPOS,nValueCurrent,0);
			UpdateWindow(hWnd);
#else
			printf("\rGnration LinePrevious %d/100                   ",nValueCurrent);
			fflush(stdout);
#endif
		}
		nValueOld=nValueCurrent;


		for (nM4NearLine=0;nM4NearLine<CURRENTY;nM4NearLine++)
		{
			cFoundCounter=0;
			for (nIndexKeyTested=0;nIndexKeyTested<nFoundCounterCurrent[nCurrentNearLine];nIndexKeyTested++)
			{
				nKeyTested=TableM0[nCurrentNearLine*TAILLEMAXICLEFPOSSIBLE+nIndexKeyTested];
				for (nIndexKeyTested2=0;nIndexKeyTested2<nFoundCounterM4[nM4NearLine];nIndexKeyTested2++)
				{
					if (nKeyTested==TableM4[nM4NearLine*TAILLEMAXICLEFPOSSIBLE+nIndexKeyTested2])
					{
						*(psPointerKey+cFoundCounter)=(short)nKeyTested;
						cFoundCounter++;
					}
					if (TableM4[nM4NearLine*TAILLEMAXICLEFPOSSIBLE+nIndexKeyTested2]>nKeyTested)
						break;
				}
			}

			m_ppsAdressKeyLinePrevious[nLineIndex*CURRENTY*CURRENTY+nCurrentNearLine*CURRENTY+nM4NearLine]=psPointerKey;
			psPointerKey+=cFoundCounter;

			m_pcKeyLinePrevious[nLineIndex*CURRENTY*CURRENTY+nCurrentNearLine*CURRENTY+nM4NearLine]=cFoundCounter;

		}

		
	}
	m_ppsAdressKeyLinePrevious[(nLineIndex+1)*CURRENTY*CURRENTY]=psPointerKey;


	return (TRUE);
}



BOOL CAjustParamDlg::LoadFileKey()
{
   
   int   nZlr;
   int   nInputValue;
#ifndef MM_LINUX
   FILE *sFile = fopen("Plugins/key.txt", "r");
#else
   char key_file[255];

   sprintf(key_file, "%s/%s", home_dir, "key.txt");
   FILE *sFile = fopen(key_file, "r");
#endif

   if(sFile == NULL)
      return FALSE;

   for(nZlr=0; nZlr<256; nZlr++)
   {
      if(fscanf(sFile, "%d\n", &nInputValue) == EOF)
         return FALSE;

      m_cKeyLine[nZlr] = (char)(nInputValue&0x1f);
   }

   fclose(sFile);
   return TRUE;
}

void CAjustParamDlg::CreateArrayKey() 
{
	int i;

	for (int nKeyTested=0;nKeyTested<128*256;nKeyTested++)
	{
		CreateLineOrder(nKeyTested,m_psArrayKey+CURRENTY*nKeyTested);

		for (i=0;i<CURRENTY;i++)
			m_psToggleArrayKey[CURRENTY*nKeyTested+m_psArrayKey[CURRENTY*nKeyTested+i]]=i;
	}
}



inline void CAjustParamDlg::CreateLineOrder(int nKey, short * psSort)
{

	int i;
	BYTE j;
	short buffer[32];
	int offset;
	int increment;

	if ((nKey<0)||(nKey>=128*256))
		nKey=0;

	offset=(nKey>>7);
	increment=((nKey&0x7f)*2+1);

	FillMemory(buffer,sizeof(buffer),0xff);	//-1

	j = (BYTE)offset;

	for (i=0;i<255;i++)
	{
		if (buffer[m_cKeyLine[j]] == -1)
			psSort[i]=m_cKeyLine[j];
		else
			psSort[i]=buffer[m_cKeyLine[j]];

		buffer [m_cKeyLine[j]] = (short)(32+i);
		j += increment; 				// Note that j is a BYTE
	}


	CopyMemory(psSort+255,buffer,sizeof(buffer));
	psSort[287]=287;

}



BOOL CAjustParamDlg::LoadFilePossibleNormal()
{
	if(!m_pbPossibleNormal)
	{
		m_pbPossibleNormal = new bool[CURRENTY*CURRENTY];
		if(!m_pbPossibleNormal)
			return FALSE;
	}


	FILE *sFile = fopen( File_PossibleNormal, "rb");

	if(sFile == NULL)
	{
		OutputDebugString( "Impossible d'ouvrir le fichier normalpos.fpc");
	   return FALSE;
	}


	if (!CheckFileID(sFile))
	{
		fclose(sFile);
		return false;
	}

	fread(m_pbPossibleNormal, sizeof(*m_pbPossibleNormal),CURRENTY*CURRENTY,sFile);


	fclose(sFile);
	return TRUE;
}


BOOL CAjustParamDlg::LoadFilePossiblePrevious()
{
	if(!m_pbPossiblePrevious)
	{
		m_pbPossiblePrevious = new bool[CURRENTY*CURRENTY];
		if(!m_pbPossiblePrevious)
			return FALSE;
	}
   
	FILE *sFile = fopen(File_PossiblePrevious, "rb");

	if(sFile == NULL)
	{
		OutputDebugString("Impossible d'ouvrir le fichier accelerepos.fpc");
	   return FALSE;
	}

	if (!CheckFileID(sFile))
	{
		fclose(sFile);
		return false;
	}

	fread(m_pbPossiblePrevious, sizeof(*m_pbPossiblePrevious),CURRENTY*CURRENTY,sFile);

	fclose(sFile);
	return TRUE;
}


void CAjustParamDlg::CheckParameter()
{
	//ligne de test normal
	if (m_nTestNormalMaxi<0)
		m_nTestNormalMaxi=0;
	if (m_nTestNormalMaxi>TESTNORMALMAXI)
		m_nTestNormalMaxi=TESTNORMALMAXI;

	//ligne de test superposition
   	if (m_nTestPreviousMaxi<0)
		m_nTestPreviousMaxi=0;
   	if (m_nTestPreviousMaxi>TESTPREVIOUSMAXI)
		m_nTestPreviousMaxi=TESTPREVIOUSMAXI;

	if (m_nTestNormalUser<0)
		m_nTestNormalUser=0;
	if (m_nTestNormalUser>TESTNORMALMAXI)
		m_nTestNormalUser=TESTNORMALMAXI;

   	if (m_nTestPreviousUser<0)
		m_nTestPreviousUser=0;
   	if (m_nTestPreviousUser>TESTPREVIOUSMAXI)
		m_nTestPreviousUser=TESTPREVIOUSMAXI;

	//Seuil violet	[NiKral]
   	if ((m_nPurpleLevel < PURPLELEVELMINI)||(m_nPurpleLevel > PURPLELEVELMAXI))
		m_nPurpleLevel = DEFAULTPURPLELEVEL;

}


void CAjustParamDlg::AutoTestLineTestMaxi()
{
	int nFrequencyProcessor=0;

	//test frequency of processor
	nFrequencyProcessor=GetCpuSpeed();
	if (nFrequencyProcessor<50)
		nFrequencyProcessor=50;
	if (nFrequencyProcessor>10000)
		nFrequencyProcessor=10000;

	m_nTestNormalUser=int(nFrequencyProcessor*0.0120)+1;	// cricri 0.0135
	if (m_nTestNormalUser>TESTNORMALMAXI)
		m_nTestNormalUser=TESTNORMALMAXI;
	if (m_nTestNormalUser<4)
		m_nTestNormalUser=4;
#ifdef MM_LINUX
	printf ("Calculate %d for TestNormalUser\n",m_nTestNormalUser);
#endif

	m_nTestPreviousUser=int(nFrequencyProcessor*0.0085)+1;	// cricri 0.095
	if (m_nTestPreviousUser>TESTPREVIOUSMAXI)
		m_nTestPreviousUser=TESTPREVIOUSMAXI;
	if (m_nTestPreviousUser<4)
		m_nTestPreviousUser=4;
#ifdef MM_LINUX
        printf ("Calculate %d for TestPreviousUser\n",m_nTestPreviousUser);
#endif

}



#ifndef MM_LINUX
void CAjustParamDlg::SetDialogData(HWND hWnd)
{
   	char pValue[60];

	SetDlgItemText(hWnd, IDC_NOM1, "");
	SetDlgItemText(hWnd, IDC_NOM2, "");

	//SendMessage(hWnd
	SendDlgItemMessage(hWnd,IDC_PROGRESS1,PBM_SETRANGE,0,MAKELPARAM(0,100));
	SendDlgItemMessage(hWnd,IDC_PROGRESS2,PBM_SETRANGE,0,MAKELPARAM(0,100));
	SendDlgItemMessage(hWnd,IDC_PROGRESS1,PBM_SETPOS,0,0);
	SendDlgItemMessage(hWnd,IDC_PROGRESS2,PBM_SETPOS,0,0);	

	//cherche le nombre d'iterration dans les fichier prsents
	m_nTestPreviousMaxi=0;
	m_nTestNormalMaxi=0;
	CheckFiles();
	
	//mmorise m_nTestPreviousMaxi
	m_nTestPreviousMaxiOld=m_nTestPreviousMaxi;
	m_nTestNormalMaxiOld=m_nTestNormalMaxi;

	if ( (m_nTestNormalUser <= 0)||(m_nTestPreviousUser <= 0)
		 || (m_nTestNormalUser > TESTNORMALMAXI)
		 || (m_nTestPreviousUser > TESTPREVIOUSMAXI))	// cricri
		AutoTestLineTestMaxi();

	if (m_nTestNormalMaxi!=TESTNORMALMAXI)
		m_nTestNormalMaxi=TESTNORMALMAXI;
	if (m_nTestPreviousMaxi!=TESTPREVIOUSMAXI)
		m_nTestPreviousMaxi=TESTPREVIOUSMAXI;

	//CheckParameter
	CheckParameter();	
	
	//FilterSecam
	CheckDlgButton(hWnd, IDC_FILTER_SECAM, m_bFilterSecam);

	//bFilterPurple
	CheckDlgButton(hWnd, IDC_FILTER_PURPLE, m_bFilterPurple);

	//bFilterAverage	cricri
	CheckDlgButton(hWnd, IDC_FILTER_AVERAGE, m_bFilterAverage);

	//bFilterSSE		NiKral
	CheckDlgButton(hWnd, IDC_FILTER_SSE, m_bFilterSSE);

	//m_bFullField
	CheckDlgButton(hWnd, IDC_DOUBLE_TRAME, m_bFullField);

	//sCapFileName		NiKral
	SetDlgItemText(hWnd, IDC_FILENAME, sCaptureFileName);

	//bCapCrypt			NiKral
	CheckDlgButton(hWnd, IDC_TYPE_IMAGE, m_bCapCrypt);

	//bCapHalfField		NiKral
	CheckDlgButton(hWnd, IDC_ONE_FRAME, m_bCapHalfField);

	//nPurpleLevel		NiKral
	sprintf(pValue, "%d", m_nPurpleLevel);
	SetDlgItemText(hWnd, IDC_PURPLE_LEVEL, pValue);

	sprintf(pValue, "%d", m_nTestNormalUser);
	SetDlgItemText(hWnd, IDC_EDIT_MOVE, pValue);

	sprintf(pValue, "%d", m_nTestPreviousUser);
	SetDlgItemText(hWnd, IDC_EDIT_FIXE, pValue);

	SendDlgItemMessage(hWnd,IDC_SLIDER_MOVE,TBM_SETRANGE,TRUE,MAKELPARAM(0,TESTNORMALMAXI));
	SendDlgItemMessage(hWnd,IDC_SLIDER_FIXE,TBM_SETRANGE,TRUE,MAKELPARAM(0,TESTPREVIOUSMAXI));
	SendDlgItemMessage(hWnd,IDC_SLIDER_MOVE,TBM_SETTICFREQ ,5,0);
	SendDlgItemMessage(hWnd,IDC_SLIDER_FIXE,TBM_SETTICFREQ ,5,0);
	SendDlgItemMessage(hWnd,IDC_SLIDER_MOVE,TBM_SETPOS,TRUE,TESTNORMALMAXI-m_nTestNormalUser);
	SendDlgItemMessage(hWnd,IDC_SLIDER_FIXE,TBM_SETPOS,TRUE,TESTPREVIOUSMAXI-m_nTestPreviousUser);

	if (!m_bAllFileCheck)
	{
		SetDlgItemText(hWnd, IDC_NOM1, "Il manque des fichiers FPC");
		SetDlgItemText(hWnd, IDC_NOM2, "Appuyez sur OK pour les gnrer");
	}

	if (!m_bFileOK[0])
	{
		SetDlgItemText(hWnd, IDC_NOM1, "Il manque le fichier key.txt !");
		SetDlgItemText(hWnd, IDC_NOM2, "");
	}
}
#endif // MM_LINUX


BOOL CAjustParamDlg::CheckFileLineNormal()
{
   
   FILE *sFile = fopen( File_LineNormal, "rb");
   int nFullSize;

   if(sFile == NULL)
      return FALSE;

	if (!CheckFileID(sFile))
	{
		fclose(sFile);
		return false;
	}

   // nombre de ligne
   fread(&m_nTestNormalMaxi, sizeof(m_nTestNormalMaxi),1,sFile);

   //taille totale
   fread(&nFullSize, sizeof(nFullSize),1,sFile);
   if (nFullSize==NULL)
	   return FALSE;


   fclose(sFile);
   return TRUE;
}


BOOL CAjustParamDlg::CheckFileLinePrevious()
{
   FILE *sFile = fopen( File_LinePrevious, "rb");
   int nFullSize;

   if(sFile == NULL)
      return FALSE;

	if (!CheckFileID(sFile))
	{
		fclose(sFile);
		return false;
	}

   // nombre de ligne
   fread(&m_nTestPreviousMaxi, sizeof(m_nTestPreviousMaxi),1,sFile);

   //taille totale
   fread(&nFullSize, sizeof(nFullSize),1,sFile);
   if (nFullSize==NULL)
	   return FALSE;


   fclose(sFile);
   return TRUE;
}



void CAjustParamDlg::DestroyArray()
{
	if(m_psCountKeyLinePrevious != NULL)
      delete[]m_psCountKeyLinePrevious;
	m_psCountKeyLinePrevious=NULL;

	if(m_ppsAdressKeyLinePrevious != NULL)
      delete[]m_ppsAdressKeyLinePrevious;
	m_ppsAdressKeyLinePrevious=NULL;
	
	if(m_pcKeyLinePrevious != NULL)
      delete[]m_pcKeyLinePrevious;
	m_pcKeyLinePrevious=NULL;

	if(m_pnPositionLinePrevious != NULL)
      delete[]m_pnPositionLinePrevious;
	m_pnPositionLinePrevious=NULL;

	if(m_pcKeyLineNormal != NULL)
      delete[]m_pcKeyLineNormal;
	m_pcKeyLineNormal=NULL;

	if(m_ppsAdressKeyLineNormal != NULL)
      delete[]m_ppsAdressKeyLineNormal;
	m_ppsAdressKeyLineNormal=NULL;

	if(m_pnPositionLineNormal != NULL)
      delete[]m_pnPositionLineNormal;
	m_pnPositionLineNormal=NULL;

	if(m_psCountKeyLineNormal != NULL)
      delete[]m_psCountKeyLineNormal;
	m_psCountKeyLineNormal=NULL;

	if(m_pbPossibleNormal != NULL)
      delete[]m_pbPossibleNormal;
	m_pbPossibleNormal=NULL;

   if(m_pbPossiblePrevious != NULL)
      delete[]m_pbPossiblePrevious;
   m_pbPossiblePrevious=NULL;

   if(m_psArrayKey != NULL)
      delete[]m_psArrayKey;
   m_psArrayKey=NULL;

   if(m_psToggleArrayKey != NULL)
      delete[]m_psToggleArrayKey;
   m_psToggleArrayKey=NULL;

}


int CAjustParamDlg::GetCpuSpeed() 
{
	int nPriorityClass;
	int nPriorityThread;
	int nTmp;
	int result;

    union {
	  _int64 ll;
	  struct { int lo;int hi ;} s;
	} time,subtime;

#ifndef MM_LINUX
	nPriorityClass = GetPriorityClass(GetCurrentProcess);
    nPriorityThread = GetThreadPriority(GetCurrentThread);
    SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
    SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
#endif

	__asm
	{
		cpuid
		rdtsc
	    mov subtime.s.lo, eax
		mov subtime.s.hi, edx

		cpuid
		rdtsc
		sub eax, subtime.s.lo
		sbb edx, subtime.s.hi
		mov subtime.s.lo, eax
		mov subtime.s.hi, edx

		cpuid
		rdtsc
	    mov subtime.s.lo, eax
		mov subtime.s.hi, edx
		cpuid
		rdtsc
		sub eax, subtime.s.lo
		sbb edx, subtime.s.hi
		mov subtime.s.lo, eax
		mov subtime.s.hi, edx

		cpuid
		rdtsc
	    mov subtime.s.lo, eax
		mov subtime.s.hi, edx
		cpuid
		rdtsc
		sub eax, subtime.s.lo
		sbb edx, subtime.s.hi
		mov subtime.s.lo, eax
		mov subtime.s.hi, edx
	}

	__asm
	{
		cpuid
		rdtsc
		mov time.s.lo, eax
		mov time.s.hi, edx
	}

	Sleep(1500);

	__asm
	{
		cpuid
		rdtsc
		sub eax, time.s.lo
		sbb edx, time.s.hi
		mov time.s.lo, eax
		mov time.s.hi, edx

	}


#ifndef MM_LINUX
	SetThreadPriority(GetCurrentThread, nPriorityThread);
	SetPriorityClass(GetCurrentProcess, nPriorityClass);
#endif

    time.ll = time.ll - subtime.ll;


	nTmp=(int)(time.ll/1500000);

	switch(nTmp%100)
	{
		case 1:  result=nTmp-1;
		break;

		case 51:  result=nTmp-1;
		break;

		case 81:  result=nTmp-1;
		break;

		case 67:  result=nTmp-1;
		break;

		case 34:  result=nTmp-1;
		break;

		case 99:  result=nTmp+1;
		break;

		case 49:  result=nTmp+1;
		break;

		case 79:  result=nTmp+1;
		break;

		case 65:  result=nTmp+1;
		break;

		case 32:  result=nTmp+1;
		break;

		default:  result=nTmp;
	 }

#ifdef MM_LINUX
	printf ("CPU speed %d MHz\n",result);
#endif
	return result;
}




#ifndef MM_LINUX
void CAjustParamDlg::ThreadBuildFPC(void *dummy )
{

	HWND hWndThreadBuildFPC=(HWND)dummy;
	CAjustParamDlg *pAjustParam = (CAjustParamDlg*)GetProp(hWndThreadBuildFPC, pAjustParamDlgeClasse);

	pAjustParam->m_bThreadBuildFPCActive=true;
	
	//generate all files
	pAjustParam->GenerateFiles(hWndThreadBuildFPC);	

	//destroy variables
	pAjustParam->DestroyArray();

	if (pAjustParam->m_bThreadBuildFPCPermit)
	{
		//les fichiers sont calculs ; on quitte la fenetre
		RemoveProp(hWndThreadBuildFPC, pAjustParamDlgeClasse);
		EndDialog(hWndThreadBuildFPC, LOWORD(IDOK));
	}
	else
	{	//nouveau calcul possible
		EnableWindow(GetDlgItem(hWndThreadBuildFPC, IDOK), TRUE);
		UpdateWindow(hWndThreadBuildFPC);
	}

	pAjustParam->DestroyAllVariables();
	pAjustParam->m_bThreadBuildFPCActive=false;

	//remplie la fenetre de dialogue
	pAjustParam->SetDialogData(hWndThreadBuildFPC);

}
#else
void CAjustParamDlg::BuildFPC(void *dummy )
{

        m_bThreadBuildFPCPermit=true;
	HWND hWndThreadBuildFPC=(HWND)dummy;

	m_bThreadBuildFPCActive=true;
	
	//generate all files
	GenerateFiles(hWndThreadBuildFPC);	

	//destroy variables
	DestroyArray();

	DestroyAllVariables();
	m_bThreadBuildFPCActive=false;

}
#endif


BOOL CAjustParamDlg::DestroyAllVariables()
{

	if(m_psArrayKey != NULL)
		delete[]m_psArrayKey;
	m_psArrayKey=NULL;

	if(m_psToggleArrayKey != NULL)
		delete[]m_psToggleArrayKey;
	m_psToggleArrayKey=NULL;

	if(m_pbPossiblePrevious != NULL)
		delete[]m_pbPossiblePrevious;
	m_pbPossiblePrevious=NULL;

	if(m_pbPossibleNormal != NULL)
		delete[]m_pbPossibleNormal;
	m_pbPossibleNormal=NULL;

	if(m_psCountKeyLineNormal != NULL)
		delete[]m_psCountKeyLineNormal;
	m_psCountKeyLineNormal=NULL;

	if(m_pnPositionLineNormal != NULL)
		delete[]m_pnPositionLineNormal;
	m_pnPositionLineNormal=NULL;

	if(m_ppsAdressKeyLineNormal != NULL)
		delete[]m_ppsAdressKeyLineNormal;
	m_ppsAdressKeyLineNormal=NULL;

	if(m_pcKeyLineNormal != NULL)
		delete[]m_pcKeyLineNormal;
	m_pcKeyLineNormal=NULL;

	if(m_pnPositionLinePrevious != NULL)
		delete[]m_pnPositionLinePrevious;
	m_pnPositionLinePrevious=NULL;

	if(m_psCountKeyLinePrevious != NULL)
		delete[]m_psCountKeyLinePrevious;
	m_psCountKeyLinePrevious=NULL;

	if(m_ppsAdressKeyLinePrevious != NULL)
		delete[]m_ppsAdressKeyLinePrevious;
	m_ppsAdressKeyLinePrevious=NULL;

	if(m_pcKeyLinePrevious != NULL)
		delete[]m_pcKeyLinePrevious;
	m_pcKeyLinePrevious=NULL;

	if(m_pnArrayMaskPurple)
		delete[]m_pnArrayMaskPurple;
	m_pnArrayMaskPurple=NULL;

	if(m_psKeyMaskPurple)
		delete[]m_psKeyMaskPurple;
	m_psKeyMaskPurple=NULL;

	if(m_pnArrayMaskChromi)
		delete[]m_pnArrayMaskChromi;
	m_pnArrayMaskChromi=NULL;

	if(m_psKeyMaskChromi)
		delete[]m_psKeyMaskChromi;
	m_psKeyMaskChromi=NULL;

	return(TRUE);
}


bool CAjustParamDlg::GenerateArrayMaskPurple(HWND hWnd)
{

	int py;
	unsigned __int64 nMask=0;
	short Table[CURRENTY];
	short TableInverse[CURRENTY];
	int nKeyTested;
	//int nOffset;
	//int nIncrement;
	int nValueCurrent=0;
	int nValueOld=0;

	for (nKeyTested=0;nKeyTested<128*256;nKeyTested++)
	{
		CreateLineOrder(nKeyTested,Table);

		for (py=0;py<CURRENTY;py++)
			TableInverse[Table[py]]=py;

		for (py=nPositionTestPurple;py<nPositionTestPurple+nLengthTestPurple;py++)
		{
			nMask=nMask<<1;
			if (TableInverse[py]>254)
				nMask|=1;
		}

		m_pnArrayMaskPurple[nKeyTested]=nMask;
	}

	//Sort table from biggest to smallest
	for (nKeyTested=0;nKeyTested<128*256;nKeyTested++)
		m_psKeyMaskPurple[nKeyTested]=nKeyTested;

	unsigned __int64 valeur_max=0;
	int position_max=0;
	int clef_temp=0;

	for (int nKeyTested1=0;nKeyTested1<128*256;nKeyTested1++)
	{
		if (!m_bThreadBuildFPCPermit)
			return false;

		//display %
		nValueCurrent=nKeyTested1*100/(128*256);
		if (nValueCurrent!=nValueOld)
		{
#ifndef MM_LINUX
			SendDlgItemMessage(hWnd,IDC_PROGRESS2,PBM_SETPOS,nValueCurrent,0);
			UpdateWindow(hWnd);
#else
			printf("\rGnration violet %d/100                     ",nValueCurrent);
			fflush(stdout);
#endif
		}
		nValueOld=nValueCurrent;

		position_max=nKeyTested1;
		valeur_max=m_pnArrayMaskPurple[nKeyTested1];
		for (int nKeyTested2=nKeyTested1+1;nKeyTested2<128*256;nKeyTested2++)
		{
			if (m_pnArrayMaskPurple[nKeyTested2]>valeur_max)
			{
				valeur_max=m_pnArrayMaskPurple[nKeyTested2];
				position_max=nKeyTested2;
			}
		}
		m_pnArrayMaskPurple[position_max]=m_pnArrayMaskPurple[nKeyTested1];
		m_pnArrayMaskPurple[nKeyTested1]=valeur_max;

		clef_temp=m_psKeyMaskPurple[nKeyTested1];
		m_psKeyMaskPurple[nKeyTested1]=m_psKeyMaskPurple[position_max];
		m_psKeyMaskPurple[position_max]=clef_temp;

	}

	return true;
}


bool CAjustParamDlg::GenerateArrayMaskChromi(HWND hWnd)
{
	int py;
	unsigned __int64 nMask=0; 
	short Table[CURRENTY];
	short TableInverse[CURRENTY];
	int nKeyTested;
	//int nOffset;
	//int nIncrement;
	int nValueCurrent=0;
	int nValueOld=0;

	for (nKeyTested=0;nKeyTested<128*256;nKeyTested++)
	{
		CreateLineOrder(nKeyTested,Table);

		for (py=0;py<CURRENTY;py++)
			TableInverse[Table[py]]=py;

		for (py=nPositionTestChromi;py<nPositionTestChromi+nLengthTestChromi;py++)
		{
			nMask=nMask<<1;
			if (TableInverse[py]>254)
				nMask|=1;
		}
		nMask=(nMask<<1|nMask)&0x7fffffffffffffffLL;
		if (TableInverse[py]>254)
			nMask|=1;

		m_pnArrayMaskChromi[nKeyTested]=nMask;
	}

	//Sort table from biggest to smallest
	for (nKeyTested=0;nKeyTested<128*256;nKeyTested++)
		m_psKeyMaskChromi[nKeyTested]=nKeyTested;

	unsigned __int64 valeur_max=0;
	int position_max=0;
	int clef_temp=0;
	int nKeyTested1;
	int nKeyTested2;

	for (nKeyTested1=0;nKeyTested1<128*256;nKeyTested1++)
	{
		if (!m_bThreadBuildFPCPermit)
			return false;

		//display %
		nValueCurrent=nKeyTested1*100/(128*256);
		if (nValueCurrent!=nValueOld)
		{
#ifndef MM_LINUX
			SendDlgItemMessage(hWnd,IDC_PROGRESS2,PBM_SETPOS,nValueCurrent,0);
			UpdateWindow(hWnd);
#else
			printf("\rGnration chrominance %d/100               ",nValueCurrent);
			fflush(stdout);
#endif
		}
		nValueOld=nValueCurrent;

		position_max=nKeyTested1;
		valeur_max=m_pnArrayMaskChromi[nKeyTested1];
		for (nKeyTested2=nKeyTested1+1;nKeyTested2<128*256;nKeyTested2++)
		{
			if (m_pnArrayMaskChromi[nKeyTested2]>valeur_max)
			{
				valeur_max=m_pnArrayMaskChromi[nKeyTested2];
				position_max=nKeyTested2;
			}
		}
		m_pnArrayMaskChromi[position_max]=m_pnArrayMaskChromi[nKeyTested1];
		m_pnArrayMaskChromi[nKeyTested1]=valeur_max;

		clef_temp=m_psKeyMaskChromi[nKeyTested1];
		m_psKeyMaskChromi[nKeyTested1]=m_psKeyMaskChromi[position_max];
		m_psKeyMaskChromi[position_max]=clef_temp;

	}

	return true;
}

bool CAjustParamDlg::CheckFilePurple()
{
   
   FILE *sFile = fopen(File_PurpleKey, "rb");

   if(sFile == NULL)
      return false;

	if (!CheckFileID(sFile))
	{
		fclose(sFile);
		return false;
	}

	// nLengthTestPurple
	int nLengthTestPurple=0;
	fread(&nLengthTestPurple, sizeof(nLengthTestPurple),1,sFile);   

	// nPositionTestPurple
	int nPositionTestPurple=0;
	fread(&nPositionTestPurple, sizeof(nPositionTestPurple),1,sFile);   
   

	fclose(sFile);

	if (nLengthTestPurple!=64)
		return false;

	if ((nPositionTestPurple+nLengthTestPurple>CURRENTY)
		||(nPositionTestPurple<0))
		return false;

   return true;
}


bool CAjustParamDlg::CheckFileChromi()
{

	FILE *sFile = fopen(File_ChromiKey, "rb");

	if(sFile == NULL)
	  return false;

	if (!CheckFileID(sFile))
	{
		fclose(sFile);
		return false;
	}

	// LongueurTestChromi
	int LongueurTestChromi=0;
	fread(&LongueurTestChromi, sizeof(LongueurTestChromi),1,sFile);   

	// PositionTestChromi
	int PositionTestChromi=0;
	fread(&PositionTestChromi, sizeof(PositionTestChromi),1,sFile);   


	fclose(sFile);

	if (LongueurTestChromi!=64)
		return false;

	if ((PositionTestChromi+LongueurTestChromi>CURRENTY)
		||(PositionTestChromi<0))
		return false;

	return true;
}


bool CAjustParamDlg::SaveFilePurple()
{

#ifndef MM_LINUX
	CreateDirectory( PLUGIN_SUBDIR,(LPSECURITY_ATTRIBUTES)NULL);	
#endif
	FILE *sFile = fopen(File_PurpleKey, "wb");

	if(sFile == NULL)
      return false;

	//file ID
	fwrite(cFileID, sizeof(cFileID),1,sFile);   
	fwrite(cFileVersion, sizeof(cFileVersion),1,sFile);   

	// nLengthTestPurple
	fwrite(&nLengthTestPurple, sizeof(nLengthTestPurple),1,sFile);   

	// nPositionTestPurple
	fwrite(&nPositionTestPurple, sizeof(nPositionTestPurple),1,sFile);   

   
	for (int nKeyTested=0;nKeyTested<128*256;nKeyTested++)
	{
	   // TablenMask
	   fwrite(m_pnArrayMaskPurple+nKeyTested, sizeof(*m_pnArrayMaskPurple),1,sFile);

	   // ClefnMask
	   fwrite(m_psKeyMaskPurple+nKeyTested, sizeof(*m_psKeyMaskPurple),1,sFile);
	}


	fclose(sFile);
	m_bUpdateFile=true;
	return true;
}


bool CAjustParamDlg::SaveFileChromi()
{
#ifndef MM_LINUX
	CreateDirectory( PLUGIN_SUBDIR,(LPSECURITY_ATTRIBUTES)NULL);	
#endif
	FILE *sFile = fopen(File_ChromiKey, "wb");

	if(sFile == NULL)
	  return false;

	//file ID
	fwrite(cFileID, sizeof(cFileID),1,sFile);   
	fwrite(cFileVersion, sizeof(cFileVersion),1,sFile);   

	// nLengthTestPurple
	fwrite(&nLengthTestChromi, sizeof(nLengthTestChromi),1,sFile);   

	// nPositionTestPurple
	fwrite(&nPositionTestChromi, sizeof(nPositionTestChromi),1,sFile);   


	for (int nKeyTested=0;nKeyTested<128*256;nKeyTested++)
	{
	   // TablenMask
	   fwrite(m_pnArrayMaskChromi+nKeyTested, sizeof(*m_pnArrayMaskChromi),1,sFile);

	   // ClefnMask
	   fwrite(m_psKeyMaskChromi+nKeyTested, sizeof(*m_psKeyMaskChromi),1,sFile);
	}

	fclose(sFile);

	m_bUpdateFile=true;

	return true;
}


void CAjustParamDlg::SetParams(int nTestNormalUser,int nTestPreviousUser,BOOL bFilterSecam,BOOL bFilterPurple,BOOL bFilterAverage, \
							   BOOL bFilterSSE,int nPurpleLevel,BOOL bFullField,char * sCapFileName,BOOL bCapCrypt,BOOL bCapHalfField)
{
	// NiKral
	m_nTestNormalUser=nTestNormalUser;
	m_nTestPreviousUser=nTestPreviousUser;
	m_bFilterSecam=(bFilterSecam!=FALSE);
	m_bFilterPurple=(bFilterPurple!=FALSE);
	m_bFilterAverage=(bFilterAverage!=FALSE);
	m_bFilterSSE=(bFilterSSE!=FALSE);
	m_bFullField=(bFullField!=FALSE);

	m_nPurpleLevel=nPurpleLevel;

	strcpy(sCaptureFileName,sCapFileName);
	m_bCapCrypt=(bCapCrypt!=FALSE);
	m_bCapHalfField=(bCapHalfField!=FALSE);
}

bool CAjustParamDlg::GetParams(int &nTestNormalUser,int &nTestPreviousUser,BOOL &bFilterSecam,BOOL &bFilterPurple,BOOL &bFilterAverage, \
							   BOOL &bFilterSSE,int &nPurpleLevel,BOOL &bFullField,char * sCapFileName,BOOL &bCapCrypt,BOOL &bCapHalfField)
{
	// NiKral
	nTestNormalUser=m_nTestNormalUser;
	nTestPreviousUser=m_nTestPreviousUser;

	if (m_bFilterSecam) bFilterSecam=TRUE;
	else bFilterSecam=FALSE;

	if (m_bFilterPurple) bFilterPurple=TRUE;
	else bFilterPurple=FALSE;

	if (m_bFilterAverage) bFilterAverage=TRUE;
	else bFilterAverage = FALSE;

	if (m_bFilterSSE) bFilterSSE=TRUE;
	else bFilterSSE=FALSE;

	if (m_bFullField) bFullField=TRUE;
	else bFullField=FALSE;

	nPurpleLevel=m_nPurpleLevel;

	strcpy(sCapFileName,sCaptureFileName);

	if (m_bCapCrypt) bCapCrypt=TRUE;
	else bCapCrypt=FALSE;

	if (m_bCapHalfField) bCapHalfField=TRUE;
	else bCapHalfField=FALSE;

	return m_bUpdateFile;	
}

bool CAjustParamDlg::CheckFileID(FILE *sFile)
{
	if (!sFile)
		return false;

	char cCheckFileID[sizeof(cFileID)];
	char cCheckFileVersion[sizeof(cFileVersion)];


	if(fread(cCheckFileID,sizeof(cCheckFileID),1,sFile)==0)
		return false;

	if(fread(cCheckFileVersion,sizeof(cCheckFileVersion),1,sFile)==0)
		return false;

	//cCheckFileID
	for (int i=0;i<sizeof(cCheckFileID);i++)
	{
		if (cCheckFileID[i]!=cFileID[i])
			return false;
	}

	//cCheckFileVersion
	for (i=0;i<sizeof(cCheckFileVersion);i++)
	{
		if (cCheckFileVersion[i]!=cFileVersion[i])
			return false;
	}

	return true;
}
