
/*********************************************************************************
 *                                                                               *
 * AjustParamDlg.h                                                               *
 *                                                                               *
 * Copyright (C) 2000/2002 Fasouil                                               *
 *                                                                               *
 *                                                                               *
 * This program is free software; you can redistribute it and/or                 *
 * modify it under the terms of the GNU General Public License                   *
 * as published by the Free Software Foundation; either version 2                *
 * of the License, or (at your option) any later version.                        *
 *                                                                               *
 *                                                                               *          
 * This program is distributed in the hope that it will be useful,               *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 *
 * GNU General Public License for more details.                                  *
 *                                                                               *
 *                                                                               *
 * You should have received a copy of the GNU General Public License             *
 * along with this program; if not, write to the Free Software                   *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.    *
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html                *
 *                                                                               *
 *                                                                               *
 * The author can be reached at fasouil@hotmail.com                              *
 *********************************************************************************/ 


#ifndef AJUSTPARAMDLG_H
#define AJUSTPARAMDLG_H


#define ECARTLIGNESUPERPOSITION 4

const int nLengthTestChromi=64;
const int nPositionTestChromi=213;	
const int nLengthTestPurple=64;
const int nPositionTestPurple=215;


#define TESTNORMALMAXI 30		//30
#define TESTPREVIOUSMAXI 20		//20

#define PURPLELEVELMINI 90		//100
#define PURPLELEVELMAXI 210		//200

class CAjustParamDlg
{

public:
	CAjustParamDlg();
	~CAjustParamDlg();
#ifndef MM_LINUX
	int DoModal(HINSTANCE hInstance,HWND hWndParent);
#endif
	void SetParams(int nTestNormalUser,int nTestPreviousUser,BOOL bFilterSecam,BOOL bFilterPurple,BOOL bFilterAverage, \
				   BOOL bFilterSSE,int nPurpleLevel,BOOL bFullField,char * sCapFileName,BOOL bCapCrypt,BOOL bCapHalfField);
	bool GetParams(int &nTestNormalUser,int &nTestPreviousUser,BOOL &bFilterSecam,BOOL &bFilterPurple,BOOL &bFilterAverage, \
				   BOOL &bFilterSSE,int &nPurpleLevel,BOOL &bFullField,char * sCapFileName,BOOL &bCapCrypt,BOOL &bCapHalfField);
#ifdef MM_LINUX
	void BuildFPC(void *dummy );
#endif	
	

protected:
#ifndef MM_LINUX
	static BOOL CALLBACK ProcessMessage(HWND hWnd,UINT uMessage,WPARAM wParam,LPARAM lParam);
#endif
	void CheckFiles();
#ifndef MM_LINUX
	BOOL GetDialogData(HWND hWnd);
#endif
	BOOL GenerateFiles(HWND hWnd);
	BOOL SaveFileLinePrevious();
	BOOL SaveFileLineNormal();
	BOOL SaveFilePossiblePrevious();
	BOOL SaveFilePossibleNormal();
	BOOL CalculPossiblePrevious(HWND hWnd);
	BOOL CalculPossibleNormal(HWND hWnd);
	BOOL GenerateLineNormal(HWND hWnd);
	BOOL GenerateLinePrevious(HWND hWnd);
	BOOL CalculLineNormal(int index_ligne,HWND hWnd,short * TableDessous,short * TableDessus);
	BOOL CalculLinePrevious(int index_ligne,HWND hWnd,short * TableM0,short * TableM4);
	void CreateArrayKey();
	BOOL LoadFilePossibleNormal();
	BOOL LoadFilePossiblePrevious();
	void CheckParameter();
	void AutoTestLineTestMaxi();
	void SetDialogData(HWND hWnd);
	BOOL CheckFileLineNormal();
	BOOL CheckFileLinePrevious();
	void DestroyArray();
	BOOL LoadFileKey();
	int GetCpuSpeed();
#ifndef MM_LINUX
	static void ThreadBuildFPC(void *dummy );
#endif
	BOOL DestroyAllVariables();
	bool GenerateArrayMaskPurple(HWND hWnd);
	bool CheckFilePurple();
	bool SaveFilePurple();
	bool CheckFileChromi();
	bool SaveFileChromi();
	bool GenerateArrayMaskChromi(HWND hWnd);
	void CreateLineOrder(int nKey, short * psSort);
	bool CheckFileID(FILE *sFile);


	BOOL m_bFileOK[7];
	bool m_bThreadBuildFPCActive;
	bool m_bThreadBuildFPCPermit;


	bool * m_pbPossiblePrevious;
	bool * m_pbPossibleNormal;
	bool m_bAllFileCheck;
	bool m_bUpdateFile;
	bool m_bFilterSecam;
	bool m_bFilterPurple;
	bool m_bFilterAverage;	// cricri
	bool m_bFilterSSE;	    // NiKral
	bool m_bFullField;

	// NiKral
	char sCaptureFileName[MAX_PATH];
	bool m_bCapCrypt;
	bool m_bCapHalfField;

	int m_nTestNormalMaxi;
	int m_nTestPreviousMaxi;
	int m_nTestNormalMaxiOld;
	int m_nTestPreviousMaxiOld;
	int	m_nTestNormalUser;
	int m_nTestPreviousUser;
	int m_nPurpleLevel;		// NiKral

	int * m_pnPositionLineNormal;
	int * m_pnPositionLinePrevious;

	short * m_psCountKeyLineNormal;
	short *(* m_ppsAdressKeyLineNormal);
	short * m_psCountKeyLinePrevious;
	short *(* m_ppsAdressKeyLinePrevious);
	short * m_psArrayKey;
	short * m_psToggleArrayKey;

	unsigned char m_cKeyLine[256];

	unsigned char * m_pcKeyLineNormal;
	unsigned char * m_pcKeyLinePrevious;

	short * m_psKeyMaskPurple;
	short * m_psKeyMaskChromi;
	unsigned __int64 * m_pnArrayMaskPurple;
	unsigned __int64 * m_pnArrayMaskChromi;

};


#endif
