#include <ch5.h>
#include <vcrypt.h>
#include <stdio.h>
#include <math.h>
#include "memcpy.h"

#ifndef PI
#define PI 3.141592654
#endif

extern int findShift_asm (unsigned char *baseline, unsigned char *line,
                          int xWidth, int skip);

int found_key, key_sign;
int known_ch5_keys = 256;

int sin_table[1024 * 4];
int cos_table[1024 * 4];

extern int scryptphase;
extern int scryptburst;


#include "cpok_odd.h"

unsigned short *key_ptr;

// w=mx+k;

//double m1l=65.993386;
//double k1l=150;
//double k1l=148;
//double k1l=360-3*66.0;
//double k1l=158;
//double k1l=168;
//double k1l=163;


//double m1r=65.994307;
//double k1r=100;
//double k1r=78.0;
//double k1r=360-4*66.0;
//double k1r=95;
//double k1r=103;
//double k1r=97;

//double m2l=-65.993384;

//double k2l=66.1949;
//double k2l=80;
//double k2l=75;
//double k2l=77;
//double k2l=78;

//double m2r=-65.994433;

//double k2r=125.0661;
//double k2r=132;
//double k2r=128;
//double k2r=125;

double m1l = 65.993386;
double m1r = 65.994307;
double m2l = -65.993384;
double m2r = -65.994433;
/*
double k1l=159;
double k1r=96;
double k2l=79;
double k2r=130;
*/
double k1l = 159;
double k1r = 95;
double k2l = 73;
double k2r = 132;

//------------------------------------------------------------------
//#define channel5DEBUG 1
//------------------------------------------------------------------
int
decodeFrame_ch5 (unsigned char *buffer, int xWidth, int blacklines)
{
  int skip, key, i, s = 0;
  int f = 2;
  int width;


  skip = 10;

  width = 778;
  skip = 68;
//buffer+=2*width*2;
  key = find_ch5_key (buffer, width, skip);
  found_key = key;

  if (key == -1)
    {
      //printf("key not found  skip: %d\n",skip); 
      return (-1);
    }


  scryptphase = get_burst (buffer, width);

//printf("key: %d  phase: %d\n",key,scryptphase);

  for (i = 0; i < 285; i++)
    {
      s = key_ptr[i];
      rotateFirstHalfLine (&buffer[2 * (i + f) * 2 * width], s, width, skip);
      fast_memcpy (&buffer[(2 * (i + f) + 1) * 2 * width],
              &buffer[2 * (i + f) * 2 * width], 2 * width);
      h_offset[i + f] = key_ptr[i];
    }

  make_color_index ();

  return (1);
}

//------------------------------------------------------------------
int
find_ch5_key (unsigned char *buffer, int xWidth, int skip)
{
  int referenzes[6] = { 40, 80, 120, 160, 180, 220 };
  int i, j, l, matches = 0;
  int shifts[287];
  short diff[10];
  int f = -2;
  int SKIP2 = skip;
  double skalierung = 1.0;

  for (i = 0; i < 6; i++)
    {
      l = referenzes[i];
      shifts[l] =
        findShift_asm (&buffer[2 * (l - 1) * 2 * xWidth],
                       &buffer[2 * l * 2 * xWidth], xWidth, skip);
    }

  for (i = 0; i < known_ch5_keys; i++)
    {
      matches = 0;

      for (j = 0; j < 6; j++)
        {
          l = referenzes[j];
          diff[j] =
            (short) ((cp_odd[i][l + f] - cp_odd[i][l - 1 + f]) * skalierung);
          if (diff[j] < 0)
            diff[j] = (short) (xWidth - SKIP2 + diff[j]);
          if (abs (diff[j] - shifts[l]) < 6)
            matches++;
        }
      if (matches > 3)
        {
#ifdef channel5DEBUG
          fprintf (stderr, "found key: %d\n", i);

          for (j = 0; j < 6; j++)
            fprintf (stderr, "shifts[%3d]: %3d  cp_odd[%3d][%3d]: %3d\n",
                     referenzes[j], shifts[referenzes[j]], i, referenzes[j],
                     diff[j]);

#endif
          key_ptr = cp_odd[i];
          key_sign = 1;
          return (i);
        }

    }

  //---------------------------------------------------------     

#ifdef channel5DEBUG
  fprintf (stderr, "no key found\n");
#endif
  return (-1);
}

//------------------------------------------------------------------
double
normal_winkel (double winkel)
{
  int j;
  double w = 0;

  if (winkel >= 0)
    {
      j = (int) winkel / 360;
      w = winkel - j * 360;
    }
  else
    {
      j = (int) (-winkel) / 360;
      w = winkel + (j + 1) * 360;
    }

  return (w);
}

//------------------------------------------------------------------
void
make_color_index ()
{
  int i;
  double w1, w2;

  for (i = 0; i < 287; i++)
    {
      if (i % 2 == scryptphase)
        {
          w1 = normal_winkel (m1l * h_offset[i] + k1l);
          w2 = normal_winkel (m1r * h_offset[i] + k1r);
          color_index_left[i] = (int) rint (w1 / 10.0);
          color_index_right[i] = (int) rint (w2 / 10.0);
        }
      else
        {
          w1 = normal_winkel (m2l * h_offset[i] + k2l);
          w2 = normal_winkel (m2r * h_offset[i] + k2r);
          color_index_left[i] = (int) rint (w1 / 10.0);
          color_index_right[i] = (int) rint (w2 / 10.0);
        }
    }

}

//------------------------------------------------------------------
int
get_burst (unsigned char *buffer, int width)
{
  int burst_phase, p;

  p = (int) buffer[2 * width * 5 + 3];
  burst_phase = 1;
  if (p < 128)
    burst_phase = 0;

  return (burst_phase);
}

//--------------------------------------------------------------
