////////////////////////////////////////////////////////////////
// MeuhMeuhTV 09/03/2001
////////////////////////////////////////////////////////////////
// Code original FASOUIL 
// Adaptation Xawdecode par Keuleu 15/04/2001
////////////////////////////////////////////////////////////////
// CFiltre
////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <stdio.h>
#include "config.h"
#include "fasouil.h"
#include "putline.h"
#include "filtre.h"
#include "memcpy.h"
void set_bluefilter_params (int filter, ...);

#ifdef ENABLE_FASOUIL

#ifndef BOOL
# define BOOL int
#endif


extern int nagra_coded;
extern int debug;

/* FASOUIL filter parameters */
FASOUIL_PARAM fasouil_param;

/* Internal variables */
static int bImageDecode = FALSE;
static int bPreviousImageDecode = FALSE;
static int bPreviousImageDecode_e = FALSE;
static int bPreviousImageDecode_o = FALSE;

static long **pPreviousLinesAddress;
static unsigned short *pPreviousSortLines;

static unsigned char pPreviousFrame[0x151000];

static long *pPreviousLinesAddress_e[288];
static unsigned short pPreviousSortLines_e[288];

static long *pPreviousLinesAddress_o[288];
static unsigned short pPreviousSortLines_o[288];


int HauteurBandeNoire = 0;
static int RaccordLigne = 32;    // ????
static int bCaptureVideo_YUV2 = TRUE;
static int bCaptureVideo_UYVY = FALSE;

SIZE TailleDecodeTrame = {
  TAILLE_DECODE_TRAME_CX,
  TAILLE_DECODE_TRAME_CY
};


static unsigned long long mask7f     = 0x7F7F7F7F7F7F7F7FLL;
static unsigned long long masklum    = 0x00FF00FF00FF00FFLL;
static unsigned long long maskcoul7f = 0x7F007F007F007F00LL;
static unsigned long long maskcoul   = 0xFF00FF00FF00FF00LL;
static unsigned long long maskcoul80 = 0x8000800080008000LL;
static unsigned long long maskfe     = 0xFEFEFEFEFEFEFEFELL;
static unsigned long long maskancienrouge  = 0x00FFFFFF00FFFFFFLL;
static unsigned long long masknouveaurouge = 0xFF000000FF000000LL;
static unsigned long long maskancienbleu   = 0xFFFF00FFFFFF00FFLL;
static unsigned long long masknouveaubleu  = 0x0000FF000000FF00LL;
static unsigned long long maskcoulsous = 0;

void
init_fasouil_filter (void)
{
  int i;

  if (debug)
    fprintf(stderr, "fasouil: init filter\n");

  //fasouil_param.bFiltreMoyenneur = TRUE;
  set_bluefilter_params(BLUEFILTER_FAS, FASOUIL_AVERAGE, TRUE, 0);

  fasouil_param.bFiltreViolet = TRUE;

  //fasouil_param.EssaiSuperposition = SUPERPOSE_STATIC;
  set_bluefilter_params(BLUEFILTER_FAS, FASOUIL_SUPERPOSE, TRUE, 0);

  //fasouil_param.bPhaseFiltreUnKonnus = TRUE;
  set_bluefilter_params(BLUEFILTER_FAS, FASOUIL_UNKONNU_PHASE, TRUE, 0);

  //fasouil_param.bFiltreAntiBavure = TRUE;
  set_bluefilter_params(BLUEFILTER_FAS, FASOUIL_SMUDGE, TRUE, 0);

  //fasouil_param.bPhaseFiltreAntiBavure = TRUE;
  set_bluefilter_params(BLUEFILTER_FAS, FASOUIL_SMUDGE_PHASE, TRUE, 0);

  //fasouil_param.iUVThresholdPCent = 20;  // 20%;
  set_bluefilter_params(BLUEFILTER_FAS, FASOUIL_UV_THRESHOLD, 20, 0);

  //fasouil_param.CoefFiltreVert = 0;
  set_bluefilter_params(BLUEFILTER_FAS, FASOUIL_GREEN_COEFF, 0, 0);

  for (i = 0; i < 288; i++)
    {
      pPreviousLinesAddress_e[i] = NULL;
      pPreviousSortLines_e[i] = 0;

      pPreviousLinesAddress_o[i] = NULL;
      pPreviousSortLines_o[i] = 0;
    }
}

//-------------------------
//////////////////////////////////////////////////////////
// EnleveLaPremiereLigne(CUneTrame * p_Frame)
//////////////////////////////////////////////////////////
// Reconstitu la premire ligne qui n'est pas capture
//////////////////////////////////////////////////////////
void
EnleveLaPremiereLigne ( /*CUneTrame * p_Frame */ long **pLinesAddress,
                       unsigned short *pSortLines)
{
  int i;
  long *adresseligne_courante, *adresseligne_dessus, *adresseligne_dessous;
  int emplacement_ligne32 = 0;
  int nBoucle_px;
  int num_ligne_remplace;
  //const unsigned long long mask7f =  0x7F7F7F7F7F7F7F7F;

  /*
  if (bModeDecode == FALSE)
    return;
  */

  if (bImageDecode == FALSE)
    return;

  // retrouve la position de la ligne 32 (et compagnis ...)
  for (num_ligne_remplace = 32; num_ligne_remplace < RaccordLigne;
       num_ligne_remplace++)
    {

      emplacement_ligne32 = 10;
      for (i = 0; i < TailleDecodeTrame.cy; i++)
        {
          if (pSortLines[i] == num_ligne_remplace)
            {
              emplacement_ligne32 = i;
              break;
            }
        }


      if (bImageDecode == TRUE)
        {

          if ((emplacement_ligne32 < TailleDecodeTrame.cy - 1) &
              (emplacement_ligne32 > 0))
            {
              adresseligne_courante = pLinesAddress[num_ligne_remplace];
              adresseligne_dessus =
                pLinesAddress[pSortLines[emplacement_ligne32 - 1]];
              adresseligne_dessous =
                pLinesAddress[pSortLines[emplacement_ligne32 + 1]];

              nBoucle_px = TailleDecodeTrame.cx / 2;
              __asm__ __volatile__ (
                                     //modif Gondos
                                     "movl        %0, %%edi       \n\t"    // adresseligne_courante
                                     "movl        %1, %%eax       \n\t"    // adresseligne_dessus
                                     "movl        %2, %%ebx       \n\t"    // adresseligne_dessous
                                     "movl        %3, %%ecx       \n\t"    // nBoucle_px

                                     ".align 16                   \n\t"
                                     "movq mask7f, %%mm2           \n\t"
                                     "EnleveLaPremiereLigne.AutrePixel:\n\t"
                                     "movq        (%%eax), %%mm0  \n\t"    //mm0=*adresse_ligne1
                                     "movq        (%%ebx), %%mm1  \n\t"    //mm1=*adresse_ligne2
                                     "psrlq       $1, %%mm0       \n\t"    //mm0=mm0>>1 (qword)
                                     "addl        $8, %%edi       \n\t"
                                     "pand        %%mm2, %%mm0    \n\t"    //mm0=mm0&mask7f
                                     "psrlq       $1, %%mm1       \n\t"    //mm1=mm1>>1 (qword)
                                     "pand        %%mm2, %%mm1    \n\t"    //mm1=mm1&mask7f
                                     "addl        $8, %%eax       \n\t"
                                     "paddb       %%mm1, %%mm0    \n\t"    //mm0=mm0+mm1 (octet)
                                     "addl        $8,%%ebx        \n\t"
                                     "movq        %%mm0, -8(%%edi)\n\t"    //stockage mm0
                                     "decl        %%ecx           \n\t"
                                     "jnz EnleveLaPremiereLigne.AutrePixel\n\t"

                                     "emms                        \n\t"    // sortie du mode MMX

                                     :    /* output regs/vars */
                                     :    /* input regs */
                                     "m" (adresseligne_courante),    /* %0 */
                                     "m" (adresseligne_dessus),    /* %1 */
                                     "m" (adresseligne_dessous),    /* %2 */
                                     "m" (nBoucle_px)    /* %3 */
                                     :    /* clobber list */
                                     "edi", "eax", "ebx", "ecx");

            }

        }
    }

  //  __asm__ __volatile__ ("emms");

}

//////////////////////////////////////////////////////////
// FiltreImage(CUneTrame * p_Frame)
//////////////////////////////////////////////////////////
// Choisie les filtres a appliquer
//////////////////////////////////////////////////////////
void
FiltreImage ( /*CUneTrame * p_Frame */ unsigned char *src,
             long **pLinesAddress, unsigned short *pSortLines,
             int parity, int save_src)
{
  int i;

  bImageDecode = (nagra_coded != 0);

  if (bImageDecode == FALSE)
    return;

  if (parity == EVEN)
    {
      // Even Frame
      pPreviousLinesAddress = pPreviousLinesAddress_e;
      pPreviousSortLines = pPreviousSortLines_e;
      bPreviousImageDecode = bPreviousImageDecode_e;
    }
  else
    {
      // Odd Frame
      pPreviousLinesAddress = pPreviousLinesAddress_o;
      pPreviousSortLines = pPreviousSortLines_o;
      bPreviousImageDecode = bPreviousImageDecode_o;
    }

  SupprimeLigneViolet ( /*p_Frame */ pLinesAddress, pSortLines);

  if (fasouil_param.CoefFiltreVert != 0)
    {
      DiminueVertATI ( /*p_Frame */ pLinesAddress, pSortLines);
    }
  
  if (fasouil_param.bFiltreAntiBavure == TRUE)
    {
      FiltreUnKonnu ( /*p_Frame */ pLinesAddress, pSortLines);
    }

  if (fasouil_param.bFiltreMoyenneur == TRUE)
    {
      MoyenneAvecPrecedanteUnPeu ( /*p_Frame */ pLinesAddress, pSortLines);

      if (save_src == TRUE)
        fast_memcpy(pPreviousFrame, src, 576 * TailleDecodeTrame.cx * 4); 
      // segfaults with 0x151000(=288*2*1536) and v4l2 (Al)

      if (parity == EVEN)
        {
          // Even Frame
          for (i = 0; i < 287; i++)
            {
              pPreviousLinesAddress_e[i] =
                (long *) pPreviousFrame + (pLinesAddress[i] - (long *) src);
              pPreviousSortLines_e[i] = pSortLines[i];
            }
        }
      else
        {
          // Odd Frame
          for (i = 0; i < 287; i++)
            {
              pPreviousLinesAddress_o[i] =
                (long *) pPreviousFrame + (pLinesAddress[i] - (long *) src);
              pPreviousSortLines_o[i] = pSortLines[i];
            }
        }
    }


  if (parity == EVEN)
    {
      // Even Frame
      bPreviousImageDecode_e = bImageDecode;
    }
  else
    {
      // Odd Frame
      bPreviousImageDecode_o = bImageDecode;
    }

}



//////////////////////////////////////////////////////////
// MoyenneAvecPrecedanteUnPeu(CUneTrame * p_Frame)
//////////////////////////////////////////////////////////
// Petit filtre passe pas sur les couleurs
//////////////////////////////////////////////////////////
void
MoyenneAvecPrecedanteUnPeu ( /*CUneTrame * p_Frame */ long **pLinesAddress,
                            unsigned short *pSortLines)
{
  int py;
  long *adresse_ligne_courante;
  long *adresse_ligne_precedante;
  int nBoucle_px;
  //unsigned long long masklum =  0x00FF00FF00FF00FF;
  //unsigned long long maskcoul7f=0x7F007F007F007F00;

  if (bImageDecode == FALSE)
    return;

  if (bPreviousImageDecode == FALSE)
    return;

  if (fasouil_param.bFiltreMoyenneur == FALSE)
    return;

  if (bCaptureVideo_UYVY == TRUE)
    {
      masklum = 0xFF00FF00FF00FF00LL;
      maskcoul7f = 0x007F007F007F007FLL;
    }

  for (py = 0 + HauteurBandeNoire; py < 287 - HauteurBandeNoire; py++)
    {
      adresse_ligne_courante = pLinesAddress[pSortLines[py]];
      adresse_ligne_precedante =
        pPreviousLinesAddress[pPreviousSortLines[py]];


      nBoucle_px = TailleDecodeTrame.cx / 2;
      __asm__ __volatile__ (
                            //modif Gondos
                            "movl        %0, %%esi       \n\t"    // adresse_ligne_precedante
                            "movl        %1, %%edi       \n\t"    // adresse_ligne_courante

                            "movl        %2, %%ecx       \n\t"    // nBoucle_px

                            ".align 16                    \n\t"
                            "movq        %3, %%mm4    \n\t" //masklum
                            "movq        %4, %%mm5 \n\t" // maskcoul7f
                            //"movq        maskcoul, %%mm6 \n\t"

                            "MoyenneAvecPrecedanteUnPeu_AutrePixel:\n\t"
                            "movq        (%%esi), %%mm0  \n\t"    // mm0=ligne_precedante
                            "movq        (%%edi), %%mm1  \n\t"    // mm1=ligne_courante                            

                            //calcul moyenne
                            "psrlq       $1, %%mm0       \n\t"    // mm0=mm0/2
                            "pand        %%mm5, %%mm0    \n\t"    // mm0=mm0&maskcoul7f

                            "movq        %%mm1, %%mm3    \n\t"    // mm3=ligne_courante
                            "psrlq       $1, %%mm3       \n\t"    // mm3=mm3/2
                            "pand        %%mm5, %%mm3    \n\t"    // mm3=mm3&maskcoul7f

                            "paddb       %%mm3, %%mm0    \n\t"    // mm0=mm0+mm3 (octet)
                            //"pand        %%mm6, %%mm0    \n\t"    // mm0=mm0&maskcoul ?????

                            //implante la nouvelle valeur
                            "pand        %%mm4, %%mm1    \n\t"    // mm1=mm1&masklum
                            "por         %%mm0, %%mm1    \n\t"    // mm1=mm1|mm0=nouvelle valeur

                            //stockage
                            "movq        %%mm1, (%%edi)\n\t"

                            "addl        $8, %%edi       \n\t"
                            "addl        $8, %%esi       \n\t"
                            "decl %%ecx                  \n\t"
                            "jnz MoyenneAvecPrecedanteUnPeu_AutrePixel\n\t"

                            "emms                        \n\t"    // sortie du mode MMX

                            :    /* output regs/vars */
                            :    /* input regs */
                            "m" (adresse_ligne_precedante),    /* %0 */
                            "m" (adresse_ligne_courante),    /* %1 */
                            "m" (nBoucle_px),    /* %2 */
                            "m" (masklum),
                            "m" (maskcoul7f)
                            :    /* clobber list */
                            "esi", "edi", "ecx");

    }


}




//////////////////////////////////////////////////////////
// SupprimeLigneViolet(CUneTrame * p_Frame)
//////////////////////////////////////////////////////////
// Enleve les lignes satures
//////////////////////////////////////////////////////////
void
SupprimeLigneViolet ( /*CUneTrame * p_Frame */ long **pLinesAddress,
                     unsigned short *pSortLines)
{
  int px, py;
  long *adresse_ligne_courante;
  unsigned int couleurYUV_courante;
  int rap;
  long *adresse_mmx, *adresse_precedent_mmx;
  int bord1, bord2;
  int phase;
  int nb_boucle;
  int nBoucle_px;
  const int increment_phase = 16;
  int seuil_violet_manquant = (TailleDecodeTrame.cx * fasouil_param.iUVThresholdPCent) / 100;    // 20%
  //unsigned long long masklum =    0x00FF00FF00FF00FF;
  //unsigned long long maskcoul =   0xFF00FF00FF00FF00;
  //unsigned long long maskcoul80 = 0x8000800080008000;

  if (bImageDecode == FALSE)
    return;

  if (fasouil_param.bFiltreViolet == FALSE)
    return;

  if (bCaptureVideo_UYVY == TRUE)
    {
      masklum = 0xFF00FF00FF00FF00LL;
      maskcoul = 0x00FF00FF00FF00FFLL;
      maskcoul80 = 0x0080008000800080LL;
    }


  bord1 = 0;
  bord2 = TailleDecodeTrame.cy;
  if (HauteurBandeNoire > 2)
    {
      bord1 = HauteurBandeNoire;
      bord2 = TailleDecodeTrame.cy - HauteurBandeNoire;
    }

  for (py = bord1; py < bord2; py++)
    {

      adresse_ligne_courante = pLinesAddress[pSortLines[py]];

      //////////////////
      rap = 0;                    // bleu
      nb_boucle = 0;
      for (phase = 0; phase < increment_phase; phase += 1)
        {
          if (bCaptureVideo_YUV2 == TRUE)
            {
              for (px = phase; px < TailleDecodeTrame.cx;
                   px += increment_phase)
                {
                  nb_boucle++;
                  couleurYUV_courante = *(adresse_ligne_courante + px);
                  if ((unsigned char) (couleurYUV_courante >> 8) > 153)
                    rap++;
                }
            }

          if (bCaptureVideo_UYVY == TRUE)
            {
              for (px = phase; px < TailleDecodeTrame.cx;
                   px += increment_phase)
                {
                  nb_boucle++;
                  couleurYUV_courante = *(adresse_ligne_courante + px);
                  if ((unsigned char) (couleurYUV_courante >> 0) > 153)
                    rap++;
                }
            }

          if (nb_boucle - rap > seuil_violet_manquant)    //il en manque x en tout
            break;
        }

      if (rap < TailleDecodeTrame.cx - seuil_violet_manquant)
        {
          rap = 0;                //rouge
          nb_boucle = 0;
          for (phase = 0; phase < increment_phase; phase += 1)
            {
              if (bCaptureVideo_YUV2 == TRUE)
                {
                  for (px = phase; px < TailleDecodeTrame.cx;
                       px += increment_phase)
                    {
                      nb_boucle++;
                      couleurYUV_courante = *(adresse_ligne_courante + px);
                      if ((unsigned char) (couleurYUV_courante >> 24) > 148)
                        rap++;
                    }
                }

              if (bCaptureVideo_UYVY == TRUE)
                {
                  for (px = phase; px < TailleDecodeTrame.cx;
                       px += increment_phase)
                    {
                      nb_boucle++;
                      couleurYUV_courante = *(adresse_ligne_courante + px);
                      if ((unsigned char) (couleurYUV_courante >> 16) > 148)
                        rap++;
                    }
                }

              if (nb_boucle - rap > seuil_violet_manquant)    //il en manque x en tout
                break;
            }
        }


      if (rap >= TailleDecodeTrame.cx - seuil_violet_manquant)
        {
          nBoucle_px = TailleDecodeTrame.cx / 2;

          if ((fasouil_param.EssaiSuperposition != 0) &
              (bPreviousImageDecode == TRUE))
            {                    //image fixe -> prend la couleur sur l'image d'avant

              adresse_mmx = adresse_ligne_courante;
              adresse_precedent_mmx =
                pPreviousLinesAddress[pPreviousSortLines[py]];

              __asm__ __volatile__ (
                                     //modif Gondos
                                     "movl         %0, %%esi       \n\t"    // adresse_precedent_mmx
                                     "movl         %1, %%edi       \n\t"    // adresse_mmx
                                     "movl         %2, %%ecx       \n\t"    // nBoucle_px

                                     ".align 16                    \n\t"
                                     "movq        masklum, %%mm2    \n\t"
                                     "movq        maskcoul, %%mm3   \n\t"

                                     "SupprimeLigneViolet_AutrePixel:\n\t"
                                     "movq        (%%esi), %%mm1   \n\t"    //mm1=ligne_precedente
                                     "movq        (%%edi), %%mm0   \n\t"    //mm0=ligne_courante
                                     "pand        %%mm3, %%mm1     \n\t"    //mm1=mm1&maskcoul

                                     //remplacement de la couleur      
                                     "pand        %%mm2, %%mm0     \n\t"    //mm0=mm0&masklum
                                     "addl        $8, %%edi        \n\t"
                                     "por         %%mm1, %%mm0     \n\t"    //mm0=mm0|mm1 ajoute la couleur precedente
                                     "addl        $8, %%esi        \n\t"

                                     //stockage
                                     "movq        %%mm0, -8(%%edi) \n\t"
                                     "decl        %%ecx            \n\t"
                                     "jnz SupprimeLigneViolet_AutrePixel\n\t"

                                     "emms                         \n\t"    // sortie du mode MMX

                                     :    /* output regs/vars */
                                     :    /* input regs */
                                     "m" (adresse_precedent_mmx),    /* %0 */
                                     "m" (adresse_mmx),    /* %1 */
                                     "m" (nBoucle_px)    /* %2 */
                                     :    /* clobber list */
                                     "esi", "edi", "ecx");

            }
          else
            {                    //image qui bouge -> on gomme la couleur          

              adresse_mmx = adresse_ligne_courante;

              __asm__ __volatile__ (
                                     //modif Gondos
                                     "movl        %0, %%edi        \n\t"    // adresse_mmx
                                     "movl        %1, %%ecx        \n\t"    // nBoucle_px

                                     ".align 16                    \n\t"
                                     "movq        maskcoul80, %%mm4 \n\t"
                                     "SupprimeLigneViolet_AutrePixel2:\n\t"
                                     "movq        (%%edi), %%mm0   \n\t"    //mm0=ligne_courante

                                     //remplacement de la couleur
                                     "pand        %%mm2, %%mm0     \n\t"    //mm0=mm0&masklum
                                     "addl        $8, %%edi        \n\t"
                                     "por         %%mm4, %%mm0     \n\t"    //mm0=mm0|maskcoul80 -> noir et blanc
                                     "decl        %%ecx            \n\t"

                                     //stockage
                                     "movq        %%mm0, -8(%%edi) \n\t"
                                     "jnz         SupprimeLigneViolet_AutrePixel2\n\t"

                                     "emms                         \n\t"    // sortie du mode MMX

                                     :    /* input regs */
                                     :    /* output regs/vars */
                                     "m" (adresse_mmx),    /* %0 */
                                     "m" (nBoucle_px)    /* %1 */
                                     :    /* clobber list */
                                     "esi", "edi", "ecx");
            }

        }

    }


}





//////////////////////////////////////////////////////////
// ReconstituUSB(CUneTrame * p_Frame)
//////////////////////////////////////////////////////////
// Reconstitu les 32 lignes de l'USB qui manquent
//////////////////////////////////////////////////////////
void
ReconstituUSB ( /*CUneTrame * p_Frame */ long **pLinesAddress,
               unsigned short *pSortLines)
{

  int py, i;
  long *adresse_ligne1, *adresse_ligne2, *adresse_ligne_courante;
  int borne1, borne2;
  int amorce;
  int ecart_ligne = 1;
  unsigned long long IncrementPixelMMX[384 / 2];
  unsigned long long *ad_IncrementPixelMMX = IncrementPixelMMX;
  int nBoucle_px;
  int coef_mmx = 1;
  //const unsigned long long mask7f =  0x7F7F7F7F7F7F7F7F;
  //const unsigned long long maskfe =  0xFEFEFEFEFEFEFEFE;

  borne1 = 0;
  borne2 = 0;
  amorce = FALSE;

  if (bImageDecode == FALSE)
    return;


  for (py = TailleDecodeTrame.cy - 1; py >= 0; py--)
    {
      if (amorce == FALSE)
        {
          if (pSortLines[py] < 33)
            {
              borne1 = py + 1;
              amorce = TRUE;
            }
        }
      if (amorce == TRUE)
        {
          if (pSortLines[py] >= 33)
            {
              borne2 = py;
              amorce = FALSE;

              adresse_ligne1 = pLinesAddress[pSortLines[borne1]];
              adresse_ligne2 = pLinesAddress[pSortLines[borne2]];
              ecart_ligne = borne1 - borne2;
              if (ecart_ligne != 0)
                coef_mmx = 256 / ecart_ligne;
              coef_mmx = (coef_mmx << 16) + (coef_mmx << 0);

              nBoucle_px = TailleDecodeTrame.cx / 2;
              __asm__ __volatile__ (
                                     //modif Gondos
                                     "movl        %0, %%edi       \n\t"    // adresse_ligne1
                                     "movl        %1, %%esi       \n\t"    // adresse_ligne2
                                     "xorl        %%edx, %%edx    \n\t"
                                     "movd        %2, %%mm0       \n\t"    // mm0=mm0 : coef_mmx
                                     "movq        %%mm0, %%mm1    \n\t"
                                     "movq        %3, %%mm6       \n\t"    // maskfe
                                     "psllq       $32, %%mm0      \n\t"    // mm0=mm0*2^32
                                     "movq        %4, %%mm7       \n\t"    // mask7f
                                     //"movd        %2, %%mm1       \n\t" // mm0=coef_mmx : coef_mmx 
                                     "por         %%mm1, %%mm0    \n\t"    // mm0=mm0|mm1
                                     "movl        %5, %%ecx       \n\t"    // nBoucle_px
                                     "movl        %6, %%ebx       \n\t"    // ad_IncrementPixelMMX


                                     ".align 16                   \n\t"
                                     "ReconstituUSB_AutrePixel:\n\t"
                                     "movq        (%%esi), %%mm2  \n\t"    // mm2=*adresse_ligne2
                                     "movq        (%%edi), %%mm1  \n\t"    // mm1=*adresse_ligne1
                                     "psrlq       $1, %%mm2       \n\t"    // mm2=mm2/2
                                     "psrlq       $1, %%mm1       \n\t"    // mm1=mm1/2
                                     "pand        %%mm7, %%mm2    \n\t"    // mask7f
                                     "pand        %%mm7, %%mm1    \n\t"    // mask7f
                                     "pxor        %%mm3, %%mm3    \n\t"    //mm3=0
                                     "psubb       %%mm1, %%mm2    \n\t"    //mm2=mm2-mm1   (octet)
                                     "pxor        %%mm4, %%mm4    \n\t"    //mm4=0
                                     //"movq        %%mm2, %%mm1    \n\t" //mm1=mm2
                                     "punpckhbw   %%mm2, %%mm3    \n\t"    //mm1=mlange mm1 avec 0
                                     "psraw       $8, %%mm3       \n\t"
                                     "punpcklbw   %%mm2, %%mm4    \n\t"    //mm2=mlange mm2 avec 0
                                     "pmullw      %%mm0, %%mm3    \n\t"    //mm3=mm3*mm0
                                     "psraw       $8, %%mm4       \n\t"
                                     "incl        %%edx           \n\t"
                                     //stall
                                     "pmullw      %%mm0, %%mm4    \n\t"    //mm4=mm4*mm0
                                     "psrlw       $8,%%mm3        \n\t"    //mm3=rotation droite w
                                     //stall                            
                                     //stall                            
                                     "addl        $8, %%edi       \n\t"
                                     "psrlw       $8, %%mm4       \n\t"    //mm4=rotation droite w
                                     "packuswb    %%mm3, %%mm4    \n\t"    //mm3=unpack mm3,mm4
                                     "psllq       $1, %%mm4       \n\t"    //mm4=mm4*2
                                     "addl        $8, %%esi       \n\t" 
                                     "pand        %%mm6, %%mm4    \n\t"    //maskfe
                                     "decl %%ecx                  \n\t"
                                     //stall
                                     "movq        %%mm4, -8(%%ebx, %%edx, 8) \n\t"    //stockage mm3
                                     "jnz ReconstituUSB_AutrePixel\n\t"

                                     "emms                        \n\t"    // Sortie du mode MMX

                                     :    /* output regs/vars */
                                     :    /* input regs */
                                     "m" (adresse_ligne1),    /* %0 */
                                     "m" (adresse_ligne2),    /* %1 */
                                     "m" (coef_mmx),    /* %2 */
                                     "m" (maskfe),    /* %3 */
                                     "m" (mask7f),    /* %4 */
                                     "m" (nBoucle_px),    /* %5 */
                                     "m" (ad_IncrementPixelMMX)    /* %6 */
                                     :    /* clobber list */
                                     "esi", "edi", "edx", "ebx", "ecx");

              for (i = borne1 - 1; i > borne2; i--)
                {
                  adresse_ligne1 = pLinesAddress[pSortLines[i + 1]];
                  adresse_ligne_courante = pLinesAddress[pSortLines[i]];

                  nBoucle_px = TailleDecodeTrame.cx / 2;
                  __asm__ __volatile__ (
                                         //modif Gondos
                                         "movl      %0, %%edi       \n\t"    // ad_IncrementPixelMMX
                                         "movl      %1, %%esi       \n\t"    // adresse_ligne1
                                         "xorl      %%edx, %%edx    \n\t"
                                         "movl      %2, %%ecx       \n\t"    // nBoucle_px
                                         "movl      %3, %%ebx       \n\t"    // adresse_ligne_courante

                                         ".align 16                 \n\t"
                                         "ReconstituUSB_AutrePixelCre:            \n\t"
                                         "movq      (%%edi), %%mm1  \n\t"    // mm1=*ad_IncrementPixelMMX
                                         "movq      (%%esi), %%mm2  \n\t"    // mm2=*adresse_ligne1
                                         "paddb     %%mm2, %%mm1    \n\t"    // mm1=mm1+mm2
                                         "incl      %%edx           \n\t"
                                         "addl      $8, %%edi       \n\t"
                                         "addl      $8, %%esi       \n\t"
                                         "movq      %%mm1, -8(%%ebx, %%eax, 8)\n\t"    // stockage mm3
                                         "decl      %%ecx           \n\t"

                                         "jnz       ReconstituUSB_AutrePixelCre   \n\t"

                                         "emms                      \n\t"    // Sortie du mode MMX

                                         :    /* output regs/vars */
                                         :    /* input regs */
                                         "m" (ad_IncrementPixelMMX),    /* %0 */
                                         "m" (adresse_ligne1),    /* %1 */
                                         "m" (nBoucle_px),    /* %2 */
                                         "m" (adresse_ligne_courante)    /* %3 */
                                         :    /* clobber list */
                                         "esi", "edi", "edx", "ebx", "ecx");

                }

            }
        }

    }

  ///////// sortie
  if (amorce == TRUE)
    {

      for (i = borne1 - 1; i >= 0; i--)
        {
          adresse_ligne1 = pLinesAddress[pSortLines[i + 1]];
          adresse_ligne_courante = pLinesAddress[pSortLines[i]];
          fast_memcpy (adresse_ligne_courante, adresse_ligne1,
                  TailleDecodeTrame.cx * sizeof (int));
        }


    }


}


//////////////////////////////////////////////////////////
// FiltreUnKonnu(CUneTrame * p_Frame)
//////////////////////////////////////////////////////////
// Filtre anti-bavures : il faut synchroniser ce filtre
//////////////////////////////////////////////////////////
void
FiltreUnKonnu ( /*CUneTrame * p_Frame */ long **pLinesAddress,
               unsigned short *pSortLines)
{                                //ide original l'1Konnu
  //modif asm Gondos

  //static const unsigned long long maskancienrouge =     0x00FFFFFF00FFFFFF;
  //static const unsigned long long masknouveaurouge=     0xFF000000FF000000;
  //static const unsigned long long maskancienbleu =      0xFFFF00FFFFFF00FF;
  //static const unsigned long long masknouveaubleu=      0x0000FF000000FF00;

  //    static int py;
  //    static int  * adresse_ligne_proche;// ,* adresse_ligne_courante;
  int bord1, bord2;
  int nBoucle_px;

  long **ptr2;
  unsigned short *ptr1;
  //    short tmp;
  int tmp_bool;


  if (bImageDecode == FALSE)
    return;

  if (fasouil_param.bFiltreAntiBavure == FALSE)
    return;

  if (HauteurBandeNoire > 2)
    {
      bord1 = HauteurBandeNoire;
      bord2 = TailleDecodeTrame.cy - HauteurBandeNoire;
    }
  else
    {
      bord1 = 1;
      bord2 = TailleDecodeTrame.cy - 1;
    }

  nBoucle_px = TailleDecodeTrame.cx / 2;


  tmp_bool = !((fasouil_param.bPhaseFiltreAntiBavure == FALSE)
               ^ (fasouil_param.bPhaseFiltreUnKonnus == FALSE)
               ^ ((bord1 & 1) != 0));

  ptr1 = pSortLines;
  ptr2 = pLinesAddress;

  //for (py=bord1;py<bord2;py++)
  //{

  __asm__ __volatile__ ("movl    %0, %%eax           \n\t"    // bord1
                        "movl    %1, %%esi           \n\t"    // ptr1
                        "movl    %2, %%ebx           \n\t"    // tmp_bool
                        "nop                         \n\t"    // evite l'AGI
                        "movswl  -2(%%esi, %%eax, 2), %%edx\n\t"
                        //4*eax-4 si on change TabOrdreLigne 
                        //en int au lieu de short

                        "movq    maskancienrouge, %%mm4  \n\t"    // mask couleur a garder 
                        "movq    masknouveaurouge, %%mm5 \n\t"    // mask couleur de remplacement
                        "movq    maskancienbleu, %%mm6   \n\t"    // mask couleur a garder
                        "movq    masknouveaubleu, %%mm7  \n\t"    // mask couleur de remplacement

                        ".align 16                   \n\t"
                        "FiltreUnKonnu_boucle:                     \n\t"
                        //adresse_ligne_proche=ptr2[tmp];
                        //adresse_ligne_courante=ptr2[tmp=ptr1[py]];
                        //edx=tmp=ptr1[py-1]
                        //eax=py
                        //ebx=tmp_bool
                        "movl    %3, %%ecx           \n\t"    // ptr2
                        "movq    %%mm4, %%mm2        \n\t"    // mask couleur a garder rouge 
                        "movl    %1, %%edi           \n\t"    // ptr1
                        "movq    %%mm5, %%mm3        \n\t"    // mask couleur de remplacement rouge
                        "movl    (%%ecx,%%edx,4), %%esi \n\t"    // adresse_ligne_proche reste dans esi
                        "movl    %3, %%ecx           \n\t"    // ptr2
                        "movswl  (%%edi, %%eax, 2), %%edx\n\t"
                        "incl    %%eax               \n\t"
                        "xorl    $1, %%ebx           \n\t"    // if(tmp_bool^=1)
                        "nop                         \n\t"    // pas d'AGI
                        "movl    (%%ecx,%%edx,4),%%edi \n\t"    // adresse_ligne_courante reste dans edi
                        "jne     FiltreUnKonnu_fincas  \n\t"
                        /////////////////////////////////////////
                        //      Si il y a plus de bleu que     //
                        //      que de  rouge a  corriger,     //
                        //      mettre un 'je' et inverser     //
                        //      mm6/mm4 et mm7/mm5 pour la     //
                        //      branch prediction...           //
                        /////////////////////////////////////////
                        "movq    %%mm6, %%mm2        \n\t"    // mask couleur a garder bleu
                        "movq    %%mm7, %%mm3        \n\t"    // mask couleur de remplacement bleu
                        "FiltreUnKonnu_fincas:                     \n\t"
                        "movl    %4, %%ecx           \n\t"    // nBoucle_px
                        "jmp     FiltreUnKonnu_AutrePixel          \n\t"
                        ".align 16                   \n\t"
                        "FiltreUnKonnu_AutrePixel:                 \n\t"
                        //lecture couleur
                        "movq    (%%edi), %%mm0      \n\t"    // mm0=adresse_ligne_courante
                        "movq    (%%esi), %%mm1      \n\t"    // mm1=adresse_ligne_proche
                        //filtrage
                        "pand    %%mm2, %%mm0        \n\t"    // mm0=mm0&mm2
                        "addl    $8, %%edi           \n\t"
                        "pand    %%mm3, %%mm1        \n\t"    // mm0=mm0&mm2
                        "addl    $8, %%esi           \n\t"
                        "por     %%mm1, %%mm0        \n\t"    // mm0=mm0|mm1
                        "decl    %%ecx               \n\t"
                        //stockage
                        "movq    %%mm0, -8(%%edi)    \n\t"    // adresse_ligne_courante=mm0
                        "jnz     FiltreUnKonnu_AutrePixel          \n\t"    // Sortie
                        "cmpl    %4, %%eax           \n\t"    // bord2
                        "jl      FiltreUnKonnu_boucle              \n\t"

                        "emms                        \n\t"    // sortie du mode MMX

                        :        /* output regs/vars */
                        :        /* input regs */
                        "m" (bord1),    /* %0 */
                        "m" (ptr1),    /* %1 */
                        "m" (tmp_bool),    /* %2 */
                        "m" (ptr2),    /* %3 */
                        "m" (bord2)    /* %4 */
                        :        /* clobber list */
                        "esi", "edi", "eax", "ebx", "ecx", "edx");

}





void
FiltreUnKonnu_old ( /*CUneTrame * p_Frame */ long **pLinesAddress,
                   unsigned short *pSortLines)
{                                //ide original l'1Konnu

  int py;
  long *adresse_ligne_courante, *adresse_ligne_proche;
  int bord1, bord2;
  int nBoucle_px;
  //unsigned long long maskancienrouge =  0x00FFFFFF00FFFFFF;
  //unsigned long long masknouveaurouge=  0xFF000000FF000000;
  //unsigned long long maskancienbleu =   0xFFFF00FFFFFF00FF;
  //unsigned long long masknouveaubleu=   0x0000FF000000FF00;


  if (bImageDecode == FALSE)
    return;

  if (fasouil_param.bFiltreAntiBavure == FALSE)
    return;

  if (bCaptureVideo_UYVY == TRUE)
    {
      maskancienrouge = 0xFF00FFFFFF00FFFFLL;
      masknouveaurouge = 0x00FF000000FF0000LL;
      maskancienbleu = 0xFFFFFF00FFFFFF00LL;
      masknouveaubleu = 0x000000FF000000FFLL;
    }

  bord1 = 1;
  bord2 = TailleDecodeTrame.cy - 1;
  if (HauteurBandeNoire > 2)
    {
      bord1 = HauteurBandeNoire;
      bord2 = TailleDecodeTrame.cy - HauteurBandeNoire;
    }

  nBoucle_px = TailleDecodeTrame.cx / 2;

  py=bord1;
  if (py++ < bord2)		//  for (py = bord1; py < bord2; py++) Catimimi 01-06-2003 compatibilit gcc 3.3
    {
      adresse_ligne_courante = pLinesAddress[pSortLines[py]];
      adresse_ligne_proche = pLinesAddress[pSortLines[py - 1]];

      //if ( ((py)&1!=0)^(bPhaseFiltreUnKonnus==FALSE))
      if (((py & 1) != 0)
          ^ (fasouil_param.bPhaseFiltreAntiBavure == FALSE)
          ^ (fasouil_param.bPhaseFiltreUnKonnus == FALSE))
        {                        //cas 1

          __asm__ __volatile__ ("movq    %mm4, %mm2       \n\t"    // mask couleur a garder rouge 
                                "movq    %mm5, %mm3       \n\t"    // mask couleur de remplacement rouge
            );
        }
      else
        {                        //cas 2
          __asm__ __volatile__ ("movq    %mm6, %mm2       \n\t"    //mask couleur a garder bleu
                                "movq    %mm7, %mm3       \n\t"    //mask couleur de remplacement bleu
            );
        }


      __asm__ __volatile__ ("movl        %0, %%edi        \n\t"    // adresse_ligne_courante
                            "movl        %1, %%esi        \n\t"    // adresse_ligne_proche
                            "movl        %2, %%ecx        \n\t"    // nBoucle_px

                            "movq    maskancienrouge, %%mm4  \n\t"    //mask couleur a garder
                            "movq    masknouveaurouge, %%mm5 \n\t"    //mask couleur de remplacement
                            "movq    maskancienbleu, %%mm6   \n\t"    //mask couleur a garder
                            "movq    masknouveaubleu, %%mm7  \n\t"    //mask couleur de remplacement

                            "FiltreUnKonnu_old_AutrePixel:                  \n\t"
                            //lecture couleur
                            "movq        (%%edi), %%mm0   \n\t"    // mm0=adresse_ligne_courante
                            "movq        (%%esi), %%mm1   \n\t"    // mm1=adresse_ligne_proche
                            //filtrage
                            "pand        %%mm2, %%mm0     \n\t"    //mm0=mm0&mm2
                            "addl        $8, %%edi        \n\t"
                            "pand        %%mm3, %%mm1     \n\t"    //mm0=mm0&mm2
                            "addl        $8, %%esi        \n\t"
                            "por         %%mm1, %%mm0     \n\t"    //mm0=mm0|mm1
                            "decl        %%ecx            \n\t"
                            //stockage
                            "movq        %%mm0, -8(%%edi) \n\t"    //adresse_ligne_courante=mm0
                            "jnz FiltreUnKonnu_old_AutrePixel               \n\t"    //Sortie

                            "emms                        \n\t"    // sortie du mode MMX

                            :    /* output regs/vars */
                            :    /* input regs */
                            "m" (adresse_ligne_courante),    /* %0 */
                            "m" (adresse_ligne_proche),    /* %1 */
                            "m" (nBoucle_px)    /* %2 */
                            :    /* clobber list */
                            "esi", "edi", "ecx");


    }


  //  __asm__ __volatile__ ("emms");


}


//////////////////////////////////////////////////////////
// VerifiPhaseFiltreUnKonnu(CUneTrame * p_Frame,BOOL bPhaseFiltre)
//////////////////////////////////////////////////////////
// Vrfie la synchronisation de filtre anti-bavure
//////////////////////////////////////////////////////////
void
VerifiPhaseFiltreUnKonnu(/*CUneTrame * p_Frame*/ long **pLinesAddress)
{ // a faire avant filtrage
  int px,py,nb;
  long * adresse_ligne_courante;
  int correl,correl_rouge,correl_bleu;
  short donnee1[144]; //288
  short donnee2[144]; //288
  //int phase0=0;
  //int phase1=0;
  const int borne1=60;
  const int borne2=TailleDecodeTrame.cy-60;
  const int nb_colonne=8;


  if (bImageDecode == FALSE)
    return;

  if (fasouil_param.bFiltreAntiBavure == FALSE)
    return;

  //if (p_Frame->bAccesInterdit)
  //  return;

  correl_rouge=0;
  correl_bleu=0;

  if (bCaptureVideo_YUV2 == TRUE)
    {
      //correlation (bleu)
      for (px = TailleDecodeTrame.cx/(nb_colonne*2+1);
           px < TailleDecodeTrame.cx; px += TailleDecodeTrame.cx / nb_colonne)
        {
          nb=0;
          for (py=borne1; py < borne2; py += 2)
            {
              adresse_ligne_courante=pLinesAddress[py]+px;
              donnee1[nb]=(unsigned char)((*adresse_ligne_courante)>>8);

              adresse_ligne_courante=pLinesAddress[py+1]+px;
              donnee2[nb]=(unsigned char)((*adresse_ligne_courante)>>8);

              nb++;

            }
          correl_bleu+=Correlation(donnee1,donnee2,nb);
          
        }
      correl_bleu=correl_bleu/nb_colonne;


      //correlation (rouge)
      for (px = TailleDecodeTrame.cx/(nb_colonne*2+1);
           px < TailleDecodeTrame.cx; px += TailleDecodeTrame.cx / nb_colonne)
        {
          nb=0;
          for (py=borne1; py < borne2; py += 2)
            {
              adresse_ligne_courante=pLinesAddress[py]+px;
              donnee1[nb]=(unsigned char)((*adresse_ligne_courante)>>24);
              
              adresse_ligne_courante=pLinesAddress[py+1]+px;
              donnee2[nb]=(unsigned char)((*adresse_ligne_courante)>>24);

              nb++;

            }
          correl_rouge+=Correlation(donnee1,donnee2,nb);

        }
      correl_rouge=correl_rouge/nb_colonne;
    }
  
 correl=(correl_bleu+(255-correl_rouge))/2;

 if (correl<128)
   fasouil_param.bPhaseFiltreUnKonnus= fasouil_param.bPhaseFiltreAntiBavure;
 else
   fasouil_param.bPhaseFiltreUnKonnus=! fasouil_param.bPhaseFiltreAntiBavure;
        
} 


//////////////////////////////////////////////////////////
// Correlation(short * donnee1,short * donnee2,int taille_donnee)
//////////////////////////////////////////////////////////
// correlation entre 2 signals
//////////////////////////////////////////////////////////
int
Correlation (short *donnee1, short *donnee2, int taille_donnee)
{                                //calcul de la correlation entre 2 signaux
  int py;
  int nBoucle;
  int moyenne1, moyenne2;
  int moyenne_carre_1, moyenne_carre_2, moyenne_produit_1_2;
  double valeur_carre_1, valeur_carre_2, valeur_produit_1_2;
  double correlation = 0;

  //
  taille_donnee = (taille_donnee / 4) * 4;
  moyenne1 = 0;
  moyenne2 = 0;
  moyenne_carre_1 = 0;
  moyenne_carre_2 = 0;
  moyenne_produit_1_2 = 0;
  //

  for (py = 0; py < taille_donnee; py++)
    {
      moyenne1 += donnee1[py];
      moyenne2 += donnee2[py];
    }
  moyenne1 = moyenne1 / taille_donnee;
  moyenne2 = moyenne2 / taille_donnee;
  //
  /*
     for (py=0;py<taille_donnee;py++)
     {
     moyenne_carre_1+=(donnee1[py]-moyenne1)*(donnee1[py]-moyenne1);
     moyenne_carre_2+=(donnee2[py]-moyenne2)*(donnee2[py]-moyenne2);
     moyenne_produit_1_2+=(donnee1[py]-moyenne1)*(donnee2[py]-moyenne2);
     }
   */
  //
  nBoucle = taille_donnee / (8 / sizeof (short));
  __asm__ __volatile__ (
                         //donnee1[py]-=moyenne1;
                         //donnee2[py]-=moyenne2;
                         //modif Gondos
                         //moyenne1
                         "movd    %0, %%mm0            \n\t"    // mm0=moyenne1 (dword)
                         "movq    %%mm0, %%mm3         \n\t"    // mm3=mm0
                         "psllq   $16, %%mm3           \n\t"    // mm3=mm3<<16
                         "movd    %1, %%mm1            \n\t"    // mm0=moyenne2 (dword)
                         "por     %%mm0, %%mm3         \n\t"    // mm3=mm3|mm0
                         "movq    %%mm1, %%mm4         \n\t"    // mm4=mm0
                         "movq    %%mm3, %%mm0         \n\t"    // mm0=mm3
                         "psllq   $32, %%mm3           \n\t"    // mm3=mm3<<32
                         "por     %%mm0, %%mm3         \n\t"    // mm3=mm3|mm0
                         //moyenne2
                         "psllq   $16, %%mm4           \n\t"    // mm4=mm4<<16
                         "por     %%mm0, %%mm4         \n\t"    // mm3=mm4|mm0
                         "movl    %2, %%edi            \n\t"    // donnee1
                         "movq    %%mm4, %%mm0         \n\t"    // mm0=mm4
                         "psllq   $32, %%mm4           \n\t"    // mm4=mm4<<32
                         "por     %%mm0, %%mm4         \n\t"    // mm4=mm4|mm0
                         "movl    %3, %%esi            \n\t"    // donnee2
                         "movl    %4, %%ecx            \n\t"    // nBoucle

                         ".align 16                    \n\t"
                         "Correlation_correl_1:                    \n\t"
                         "movq    (%%edi), %%mm1       \n\t"    // mm1=donnee1[]
                         "movq    (%%esi), %%mm2       \n\t"    // mm2=donnee2[]
                         "psubw   %%mm3, %%mm1         \n\t"    // mm1=mm1-mm3 (word)
                         "psubw   %%mm4, %%mm2         \n\t"    // mm1=mm1-mm3 (word)
                         //stockage
                         "movq    %%mm1, (%%edi)       \n\t"    // donnee1[]=mm1
                         "movq    %%mm2, (%%esi)       \n\t"    // donnee2[]=mm2
                         "addl    $8, %%edi            \n\t"    // edi=edi+8
                         "addl    $8, %%esi            \n\t"    // esi=esi+8
                         "decl %%ecx                   \n\t"
                         "jnz Correlation_correl_1                 \n\t"

                         "emms                        \n\t"    // sortie du mode MMX

                         :    /* output regs/vars */
                         :        /* input regs */
                         "m" (moyenne1),    /* %0 */
                         "m" (moyenne2),    /* %1 */
                         "m" (donnee1),    /* %2 */
                         "m" (donnee2),    /* %3 */
                         "m" (nBoucle)    /* %4 */
                         :        /* clobber list */
                         "esi", "edi", "ecx");
  //
  __asm__ __volatile__ (
                         //moyenne_carre_1+=donnee1[py]*donnee1[py];
                         //moyenne_carre_2+=donnee2[py]*donnee2[py];
                         //moyenne_produit_1_2+=donnee1[py]*donnee2[py];
                         //modif Gondos
                         "pxor    %%mm3, %%mm3         \n\t"    // mm3=0   moyenne_carre_1
                         "pxor    %%mm4, %%mm4         \n\t"    // mm4=0   moyenne_carre_2
                         "pxor    %%mm5, %%mm5         \n\t"    // mm5=0   moyenne_produit_1_2
                         "movl    %3, %%edi            \n\t"    // donnee1
                         "movl    %4, %%esi            \n\t"    // donnee2
                         "movl    %5, %%ecx            \n\t"    // nBoucle

                         ".align 16                    \n\t"
                         "Correlation_correl_2:                    \n\t"
                         "movq    (%%edi), %%mm1       \n\t"    // mm1=donnee1[]
                         "movq    %%mm1, %%mm0         \n\t"    // mm0=mm1
                         "movq    (%%esi), %%mm2       \n\t"    // mm2=donnee2[]
                         "pmaddwd %%mm1, %%mm0         \n\t"    // mm0=mm0*mm1 (word) et addition des 2 dword
                         "paddd   %%mm0, %%mm3         \n\t"    // mm3=mm3+mm0
                         "movq    %%mm2, %%mm0         \n\t"    // mm0=mm2
                         "pmaddwd %%mm2, %%mm0         \n\t"    // mm0=mm0*mm2 (word) et addition des 2 dword
                         "addl    $8, %%esi            \n\t"    // esi=esi+8
                         "paddd   %%mm0, %%mm4         \n\t"    // mm4=mm4+mm0 (dword)
                         "movq    %%mm1, %%mm0         \n\t"    // mm0=mm1
                         "pmaddwd %%mm2, %%mm0         \n\t"    // mm0=mm0*mm2 (word) et addition des 2 dword
                         "addl    $8, %%edi            \n\t"    // edi=edi+8
                         "paddd   %%mm0, %%mm5         \n\t"    // mm5=mm5+mm0  (dword)
                         "decl    %%ecx                \n\t"
                         "jnz     Correlation_correl_2             \n\t"
                         //moyenne_carre_1
                         "movd    %%mm3, %0            \n\t"    // moyenne_carre_1=mm3 (dword)
                         "psrlq   $32, %%mm3           \n\t"    // mm3=mm3>>32
                         "movd    %%mm3, %%eax         \n\t"    // eax=mm3 (dword)
                         "addl    %%eax, %0            \n\t"    // moyenne_carre_1=moyenne_carre_1+eax
                         //moyenne_carre_2
                         "movd    %%mm4, %1            \n\t"    // moyenne_carre_2=mm4 (dword)
                         "psrlq   $32, %%mm4           \n\t"    // mm4=mm4>>32
                         "movd    %%mm4, %%eax         \n\t"    // eax=mm4 (dword)
                         "addl    %%eax, %1            \n\t"    // moyenne_carre_2=moyenne_carre_2+eax
                         //moyenne_produit_1_2
                         "movd    %%mm5, %2            \n\t"    // moyenne_produit_1_2=mm5 (dword)
                         "psrlq   $32, %%mm5           \n\t"    // mm5=mm5>>32
                         "movd    %%mm5, %%eax         \n\t"    // eax=mm5 (dword)
                         "addl    %%eax, %1            \n\t"    // moyenne_produit_1_2=moyenne_produit_1_2+eax

                         "emms                        \n\t"    // sortie du mode MMX

                         :        /* output regs/vars */
                         "=m" (moyenne_carre_1),    /* %0 */
                         "=m" (moyenne_carre_2),    /* %1 */
                         "=m" (moyenne_produit_1_2)    /* %2 */
                         :        /* input regs */
                         "m" (donnee1),    /* %3 */
                         "m" (donnee2),    /* %4 */
                         "m" (nBoucle)    /* %5 */
                         :        /* clobber list */
                         "esi", "edi", "eax", "ecx");

  //  __asm__ __volatile__ ("emms");    // sortie du mode MMX

  valeur_carre_1 = moyenne_carre_1;
  valeur_carre_2 = moyenne_carre_2;
  valeur_produit_1_2 = moyenne_produit_1_2;


  if ((moyenne_carre_1 != 0) & (moyenne_carre_2 != 0))
    correlation =
      valeur_produit_1_2 * valeur_produit_1_2 * 255 / (valeur_carre_1 *
                                                       valeur_carre_2);


  return ((int) correlation);

}


//////////////////////////////////////////////////////////
// DiminueVertATI(CUneTrame * p_Frame)
//////////////////////////////////////////////////////////
// filtre le vert sur une image (typique de l'ATI)
//////////////////////////////////////////////////////////
void
DiminueVertATI ( /*CUneTrame * p_Frame */ long **pLinesAddress,
                unsigned short *pSortLines)
{

  int py;
  long *adresse_ligne_courante;
  int bord1, bord2;
  int nBoucle_px;
  //unsigned long long masklum =          0x00FF00FF00FF00FF;
  //unsigned long long maskcoul =         0xFF00FF00FF00FF00;
  //unsigned long long maskcoulsous =     (CoefFiltreVert<<8)+(CoefFiltreVert<<24);

  if (fasouil_param.CoefFiltreVert == 0)
    return;

  if (bImageDecode == FALSE)
    return;

  maskcoulsous = (fasouil_param.CoefFiltreVert << 8) + (fasouil_param.CoefFiltreVert << 24);

  if (bCaptureVideo_UYVY == TRUE)
    {
      masklum = 0xFF00FF00FF00FF00LL;
      maskcoul = 0x00FF00FF00FF00FFLL;
      maskcoulsous = (fasouil_param.CoefFiltreVert << 0) + (fasouil_param.CoefFiltreVert << 16);
    }

  bord1 = 0;
  bord2 = TailleDecodeTrame.cy;
  if (HauteurBandeNoire > 2)
    {
      bord1 = HauteurBandeNoire;
      bord2 = TailleDecodeTrame.cy - HauteurBandeNoire;
    }

  nBoucle_px = TailleDecodeTrame.cx / 2;
  __asm__ __volatile__ ("movq    masklum, %mm4      \n\t"
                        "movq    maskcoul, %mm5     \n\t"
                        "movd    maskcoulsous, %mm7 \n\t"
                        "psllq   $32, %mm7          \n\t"
                        "movd    maskcoulsous, %mm6 \n\t"
                        "por     %mm7, %mm6        \n\t");


  for (py = bord1; py < bord2; py++)
    {
      adresse_ligne_courante = pLinesAddress[pSortLines[py]];

      __asm__ __volatile__ ("movl        %0, %%edi        \n\t"    // adresse_ligne_courante
                            "movl        %1, %%ecx        \n\t"    // nBoucle_px
                            "DiminueVertATI_AutrePixel:                  \n\t"
                            //lecture couleur
                            "movq        (%%edi), %%mm0   \n\t"    // mm0=adresse_ligne_courante
                            "movq        %%mm0, %%mm1     \n\t"    // mm1=mm0
                            "pand        %%mm5, %%mm0     \n\t"    // mm0=mm0&maskcoul
                            "pand        %%mm4, %%mm1     \n\t"    // mm1=mm1&masklum
                            "paddusb     %%mm6, %%mm0     \n\t"    // mm0=mm0+mm6 (octet satur)
                            "addl        $8, %%edi        \n\t"
                            "por         %%mm1, %%mm0     \n\t"
                            "decl        %%ecx            \n\t"
                            //stockage                          
                            "movq        %%mm0, -8(%%edi) \n\t"    // adresse_ligne_courante=mm0
                            "jnz         DiminueVertATI_AutrePixel   \n\t"    // Sortie

                            :    /* output regs/vars */
                            :    /* input regs */
                            "m" (adresse_ligne_courante),    /* %0 */
                            "m" (nBoucle_px)    /* %1 */
                            :    /* clobber list */
                            "edi", "ecx");


    }


  __asm__ __volatile__ ("emms");    // sortie du mode MMX

}
#endif
